package org.jythonx.modules;

import org.python.core.*;
import java.util.*;

public final class _functoolsmodule{

    public static PyType partial = _partial.type;

    public static class _partial extends PyObject implements PyType.Newstyle{

        public static PyType type = PyType.fromClass(_partial.class);
	public static final String exposed_name = "functools.partial";
        public final static String[] __members__ = {"__dict__", "func", "args", "keywords"};
        public static void typeSetup(PyObject dict, PyType.Newstyle marker){
             dict.__setitem__("__new__",new PyNewWrapper(_partial.class,"__new__",-1,-1) {
                 public PyObject new_impl(boolean init,PyType subtype,PyObject[]args,String[]keywords) {
                     return partial_new(subtype,args,keywords);
                 }
            });


        }

        public static PyObject partial_new(PyType subtype, PyObject[] args, String[] kwords){

            if(args.length == 0)
                throw Py.TypeError("type 'partial' takes at least one argument");
            PyObject func = args[0];
            if(!func.isCallable())
                throw Py.TypeError("the first argument must be callable");

            _partial obj = new _partial(subtype);
            obj.fn = func;
            PyObject[] args2 = new PyObject[args.length - 1];            
            System.arraycopy(args, 1, args2, 0, args2.length);
            obj.args = args2;
            obj.kw = kwords.clone();
            return obj;
        }

        PyObject fn;
        PyObject[] args;
        String[] kw;
        PyObject dict;
        public _partial(PyType type){
            super(type);
        }

        @Override
        public PyObject fastGetDict(){ return getDict(); }

        @Override
        public PyObject getDict(){
            if(dict == null)
                dict = new PyDictionary();
            return dict;
        }

        @Override
	public boolean isCallable(){ return true; }

        @Override
	public PyObject __call__(PyObject[] args, String[] kwords){
            PyObject[] argappl = null;
            if(this.args.length == 0)
                argappl = args;
            else if(args.length == 0)
                argappl = this.args;
            else{
                if(kw.length == 0 && kwords.length == 0){
		    argappl = new PyObject[this.args.length + args.length];
                    System.arraycopy(this.args, 0, argappl, 0, this.args.length);
                    System.arraycopy(args, 0, argappl, this.args.length, args.length);
                }
            }

            String[] kwappl;
            if(this.kw.length == 0 && kwords.length == 0)
                kwappl = kwords;
            else{
                HashMap<String, PyObject> map = new HashMap<String, PyObject>();
                PyObject[] arg1 = breakIntoArgsKwds(this.args, this.kw, map);
                PyObject[] arg2 = breakIntoArgsKwds(args, kwords, map);
		argappl = new PyObject[arg1.length + arg2.length + map.size()];
                System.arraycopy(arg1, 0, argappl, 0, arg1.length);
                System.arraycopy(arg2, 0, argappl, arg1.length, arg2.length);
		kwappl = new String[map.size()];
                Iterator<String> keys = map.keySet().iterator();
		for(int i = 0, j = arg1.length + arg2.length; i < kwappl.length; i++, j++){
		    String key = keys.next();
                    kwappl[i] = key;
                    argappl[j] = map.get(key);
		}
            }
            return fn.__call__(argappl , kwappl);
	}

        public static PyObject[] breakIntoArgsKwds(PyObject[] args, String[] kwords, Map map){
            int start = args.length - kwords.length;
            for(int i = 0; i < kwords.length; i++, start++){
                if(map != null)
	            map.put(kwords[i], args[start]);
            }
            PyObject[] rv = new PyObject[args.length - kwords.length];
            System.arraycopy(args, 0, rv, 0, rv.length);
            return rv;
	}

        private void throwReadonly() {
            throw Py.TypeError("readonly attribute");
        }

        @Override
        protected void addKeys(PyDictionary dict, String attr){
	    if(attr == "__members__"){
		dict.__setitem__("__dict__", Py.None);
                dict.__setitem__("func", Py.None);
                dict.__setitem__("args", Py.None);
                dict.__setitem__("kwords", Py.None);
            } else super.addKeys(dict, attr);
        }

        @Override
        public PyObject __findattr__(String name){
	    if(name == "__dict__") return getDict();
            else if(name == "func") return fn;
            else if(name == "args"){
		return new PyTuple(breakIntoArgsKwds(args, kw, null));
            }
            else if(name == "kwords"){
                Hashtable map = new Hashtable();
                breakIntoArgsKwds(args, kw, map);
                return new PyDictionary(map);
            }
            return super.__findattr__(name);
        }

        @Override
        public void __delattr__(String name){
	    if(name == "__dict__") throwReadonly();
            else if(name == "func") throwReadonly();
            else if(name == "args") throwReadonly();
            else if(name == "kwords") throwReadonly();
            super.__delattr__(name);
        }

        @Override
	public void __setattr__(String name, PyObject value){
	    if(name == "__dict__"){
	        if (value == null) {
		    throw Py.TypeError("a partial object's dictionary may not be deleted");
	        }
	        /* Can only set __dict__ to a dictionary */
		if (!(value instanceof PyDictionary)) {
		    throw Py.TypeError("setting partial object's dictionary to a non-dict");
	        }
                dict = value;
                return;
            }
            else if(name == "func") throwReadonly();
            else if(name == "args") throwReadonly();
            else if(name == "kwords") throwReadonly();
            super.__setattr__(name, value);
        }

    }





}