package org.jythonx.bzip2;

public interface BZConstants{

    static final long UINT32 = 4294967295L;
    static final int UINT16 = 65535;

    static long[] BZ2_crc32Table = crctable.BZ2_crc32Table;
    static int[] BZ2_rNums = randtable.BZ2_rNums;

    static final int BZ_MAX_UNUSED = 5000;

    static final byte BZ_HDR_B = 0x42;   /* 'B' */
    static final byte BZ_HDR_Z = 0x5a;   /* 'Z' */
    static final byte BZ_HDR_h = 0x68;   /* 'h' */
    static final byte BZ_HDR_0 = 0x30;   /* '0' */
  
    /*-- Constants for the back end. --*/

    static final int BZ_MAX_ALPHA_SIZE = 258;
    static final int BZ_MAX_CODE_LEN = 23;

    static final byte BZ_RUNA = 0;
    static final byte BZ_RUNB = 1;

    static final int BZ_N_GROUPS = 6;
    static final int BZ_G_SIZE = 50;
    static final int BZ_N_ITERS = 4;
    static final int BZ_MAX_SELECTORS = (2 + (900000 / BZ_G_SIZE));


    /*-- States and modes for compression. --*/

    static final int BZ_M_IDLE = 1;
    static final int BZ_M_RUNNING = 2;
    static final int BZ_M_FLUSHING = 3;
    static final int BZ_M_FINISHING = 4;

    static final int BZ_S_OUTPUT = 1;
    static final int BZ_S_INPUT = 2;

    static final int BZ_N_RADIX = 2;
    static final int BZ_N_QSORT = 12;
    static final int BZ_N_SHELL = 18;
    static final int BZ_N_OVERSHOOT = (BZ_N_RADIX + BZ_N_QSORT + BZ_N_SHELL + 2);



    /*-- states for decompression. --*/

    static final int BZ_X_IDLE = 1;
    static final int BZ_X_OUTPUT = 2;
    static final int BZ_X_MAGIC_1 = 10;
    static final int BZ_X_MAGIC_2 = 11;
    static final int BZ_X_MAGIC_3 = 12;
    static final int BZ_X_MAGIC_4 = 13;
    static final int BZ_X_BLKHDR_1 = 14;
    static final int BZ_X_BLKHDR_2 = 15;
    static final int BZ_X_BLKHDR_3 = 16;
    static final int BZ_X_BLKHDR_4 = 17;
    static final int BZ_X_BLKHDR_5 = 18;
    static final int BZ_X_BLKHDR_6 = 19;
    static final int BZ_X_BCRC_1 = 20;
    static final int BZ_X_BCRC_2 = 21;
    static final int BZ_X_BCRC_3 = 22;
    static final int BZ_X_BCRC_4 = 23;
    static final int BZ_X_RANDBIT = 24;
    static final int BZ_X_ORIGPTR_1 = 25;
    static final int BZ_X_ORIGPTR_2 = 26;
    static final int BZ_X_ORIGPTR_3 = 27;
    static final int BZ_X_MAPPING_1 = 28;
    static final int BZ_X_MAPPING_2 = 29;
    static final int BZ_X_SELECTOR_1 = 30;
    static final int BZ_X_SELECTOR_2 = 31;
    static final int BZ_X_SELECTOR_3 = 32;
    static final int BZ_X_CODING_1 = 33;
    static final int BZ_X_CODING_2 = 34;
    static final int BZ_X_CODING_3 = 35;
    static final int BZ_X_MTF_1 = 36;
    static final int BZ_X_MTF_2 = 37;
    static final int BZ_X_MTF_3 = 38;
    static final int BZ_X_MTF_4 = 39;
    static final int BZ_X_MTF_5 = 40;
    static final int BZ_X_MTF_6 = 41;
    static final int BZ_X_ENDHDR_2 = 42;
    static final int BZ_X_ENDHDR_3 = 43;
    static final int BZ_X_ENDHDR_4 = 44;
    static final int BZ_X_ENDHDR_5 = 45;
    static final int BZ_X_ENDHDR_6 = 46;
    static final int BZ_X_CCRC_1 =47;
    static final int BZ_X_CCRC_2 =48;
    static final int BZ_X_CCRC_3 = 49;
    static final int BZ_X_CCRC_4 = 50;

    /*-- Constants for the fast MTF decoder. --*/
    static final int MTFA_SIZE = 4096;
    static final int MTFL_SIZE =  16;


    static final int BZ_RUN = 0;
    static final int BZ_FLUSH = 1;
    static final int BZ_FINISH = 2;

    static final int BZ_OK = 0;
    static final int BZ_RUN_OK = 1;
    static final int BZ_FLUSH_OK = 2;
    static final int BZ_FINISH_OK =3;
    static final int BZ_STREAM_END =4;
    static final int BZ_SEQUENCE_ERROR =(-1);
    static final int BZ_PARAM_ERROR  =(-2);
    static final int BZ_MEM_ERROR =(-3);
    static final int BZ_DATA_ERROR =(-4);
    static final int BZ_DATA_ERROR_MAGIC =(-5);
    static final int BZ_IO_ERROR = (-6);
    static final int BZ_UNEXPECTED_EOF =(-7);
    static final int BZ_OUTBUFF_FULL =(-8);
    static final int BZ_CONFIG_ERROR = (-9);

}