package org.jythonx.bzip2;

/*-- Structure holding all the decompression-side stuff. --*/
public class DState implements BZConstants{
    /** pointer back to the struct bz_stream */
      //bz_stream* strm;
      public bz_stream strm;

    /** state indicator for this stream */
      public int    state;

    /** for doing the final run-length decoding */
      public byte    state_out_ch;
      public int    state_out_len;
      public boolean     blockRandomised;
    //BZ_RAND_DECLS;
      public int rNToGo;
      public int rTPos;

    /** the buffer for bit stream reading */
      public long   bsBuff; //UINT32
      public int    bsLive;

    /** misc administratium */
      public int    blockSize100k;
      public boolean     smallDecompress;
      public int    currBlockNo;
      public int    verbosity;

      /** for undoing the Burrows-Wheeler transform */
      public int    origPtr;
      public long   tPos; //UINT32
      public int    k0;
      public int[] unzftab = new int[256];
      public int  nblock_used;
      public int[]  cftab = new int[257];
      public int[]  cftabCopy = new int[257];

     /** for undoing the Burrows-Wheeler transform (FAST) */
      public IntView tt; //UInt32

    /** for undoing the Burrows-Wheeler transform (SMALL) */
      public ShortView ll16; //UINt16
      public byte[] ll4; //UChar

    /** stored and calculated CRCs */ //All UInt32s
      public long   storedBlockCRC;
      public long   storedCombinedCRC;
      public long   calculatedBlockCRC;
      public long   calculatedCombinedCRC;

    /** map of bytes used in block */
      public int    nInUse;
      public boolean[] inUse = new boolean[256];
      public boolean[] inUse16 = new boolean[16];
      public byte[] seqToUnseq = new byte[256]; //UChar

    /** for decoding the MTF values */
      public byte[] mtfa = new byte[MTFA_SIZE]; //UChar
      public int[] mtfbase = new int[256 / MTFL_SIZE];
      public byte[] selector = new byte[BZ_MAX_SELECTORS]; //Uchar
      public byte[] selectorMtf = new byte[BZ_MAX_SELECTORS]; //UChar
      public byte[][] len = new byte[BZ_N_GROUPS][BZ_MAX_ALPHA_SIZE]; //UChar

      public int[][] limit = new int[BZ_N_GROUPS][BZ_MAX_ALPHA_SIZE];
      public int[][] base = new int[BZ_N_GROUPS][BZ_MAX_ALPHA_SIZE];
      public int[][] perm = new int[BZ_N_GROUPS][BZ_MAX_ALPHA_SIZE];
      public int[] minLens = new int[BZ_N_GROUPS];

      /* save area for scalars in the main decompress code */
      public int save_i;
      public int save_j;
      public int save_t;
      public int save_alphaSize;
      public int save_nGroups;
      public int save_nSelectors;
      public int save_EOB;
      public int save_groupNo;
      public int save_groupPos;
      public int save_nextSym;
      public int save_nblockMAX;
      public int save_nblock;
      public int save_es;
      public int save_N;
      public int save_curr;
      public int save_zt;
      public int save_zn; 
      public int save_zvec;
      public int save_zj;
      public int save_gSel;
      public int save_gMinlen;
      public int[] save_gLimit = new int[1];
      public int[] save_gBase = new int[1];
      public int[] save_gPerm = new int[1];

      ///Screwy way to return multiple values easily from the smallDecompress1 method
      int _i, _j;
      byte _uc;

}
