package org.jythonx.bzip2;

import java.nio.*;

/*-- Structure holding all the compression-side stuff. --*/
public class EState implements BZConstants{
      /* pointer back to the struct bz_stream */
      //bz_stream* strm;
      public bz_stream strm;

      /* mode this stream is in, and whether inputting */
      /* or outputting data */
      public int    mode;
      public int    state;

      /* remembers avail_in when flush/finish requested */
      public long   avail_in_expect;

      /* for doing the block sorting */
      public IntView  arr1; //UInt32*
      public IntView  arr2; //UInt32*
      public IntView  ftab; //UInt32*
      public int  origPtr;

      /* aliases for arr1 and arr2 */
      public IntView ptr; //UInt32*;
      public byte[] block; //UChar*
      public ShortView  mtfv; //UInt16*;
      //public ByteBuffer  zbits; //UChar* zbits
      public byte[] zbits;
      public int zbstart;

      /* for deciding when to use the fallback sorting algorithm */
      public int    workFactor;

      /* run-length-encoding of the input */
      public long state_in_ch;
      public int    state_in_len;
    //BZ_RAND_DECLS;
      public int rNToGo;
      public int rTPos;

      /* input and output limits and current posns */
      public int    nblock;
      public int    nblockMAX;
      public int    numZ;
      public int    state_out_pos;

      /* map of bytes used in block */
      public int    nInUse;
      public boolean[]     inUse = new boolean[256];
      public byte[]    unseqToSeq = new byte[256];

      /* the buffer for bit stream creation */
      public long   bsBuff;
      public int    bsLive;

      /* block and combined CRCs */
      public long   blockCRC;
      public long   combinedCRC;

      /* misc administratium */
      public int    verbosity;
      public int    blockNo;
      public int    blockSize100k;

      /* stuff for coding the MTF values */
      public int    nMTF;
      public int[]    mtfFreq    = new int[BZ_MAX_ALPHA_SIZE];
      public byte[]    selector  = new byte[BZ_MAX_SELECTORS];
      public byte[]    selectorMtf = new byte[BZ_MAX_SELECTORS];

      public byte[][] len = new byte[BZ_N_GROUPS][BZ_MAX_ALPHA_SIZE];
      public int[][] code = new int[BZ_N_GROUPS][BZ_MAX_ALPHA_SIZE];
      public int[][] rfreq = new int[BZ_N_GROUPS][BZ_MAX_ALPHA_SIZE];
      /* second dimension: only 3 needed; 4 makes index calculations faster */
      public long[][] len_pack = new long[BZ_MAX_ALPHA_SIZE][4];

}
