package org.jythonx.bzip2;


public class IntView{
    byte[] b;
    byte[] copy;
    //byte[] sarray;
    //byte tmp1, tmp2, tmp3, tmp4;
    IntView(byte[] b){ this.b = b;}
     
    public void snapshot(){
        if(copy == null) copy = new byte[b.length];
        System.arraycopy(b, 0, copy, 0, copy.length);
    }

    public void restore(){
        System.arraycopy(copy, 0, b, 0, b.length);
    }

    public int get(int i){
        //i *=4;
        i <<= 2;
        return ((b[i++] & 0xff) << 24) | 
               ((b[i++] & 0xff)<<16)| 
	       ((b[i++] & 0xff)<<8)|
	       (b[i] & 0xff);
    }

    public long getUInt32(int i){
        //i *=4;
        i <<= 2;
        return (((long)(b[i++] & 0xff) << 24)|
	              ((b[i++] & 0xff) << 16)|
	              ((b[i++] & 0xff) << 8)|
		      (b[i] & 0xff));

	//(((long)((byte)(i >> 24)) & 0xff) << 24)
	//          |
	//  (((long)((byte)(i >> 16)) & 0xff) << 16)
	//          |
	//  (((long)((byte)(i >> 8)) & 0xff) << 8)
	//          |
	//  (long)((byte)i) & 0xff;

    }

    public void put(int i, int j){
        //i *=4;
        i <<= 2;
        b[i++] = (byte)(j >> 24);
        b[i++] = (byte)(j>> 16);
        b[i++] = (byte)(j>>8);
        b[i] = (byte)j;
    }

    public int capacity(){ return b.length/4; }

    public boolean ISSET(int zz){
        int zz2 = (zz >> 5) << 2;
        return ((((long)(b[zz2++] & 0xff) << 24) | ((b[zz2++] & 0xff)<<16)| 
		  ((b[zz2++] & 0xff) << 8) | (b[zz2] & 0xff)) & 
	      (1 << ((zz) & 31))) != 0;
    }

    public void CLEAR(int zz){
        //CLEAR_BH(zz)  bhtab[(zz) >> 5] &= ~(1 << ((zz) & 31))
        //int i = (zz >> 5) * 4;
        int i = (zz >> 5) << 2;
        int j = ~(1 << ((zz) & 31));
        b[i++] &= (j >> 24);
        b[i++] &= (j>> 16);
        b[i++] &= (j>>8);
        b[i] &= j;

    }

    public void SET(int zz){
        //SET_BH(zz)  bhtab[(zz) >> 5] |= (1 << ((zz) & 31))
        //int i = (zz >> 5) * 4;
        int i = (zz >> 5) << 2;
        int j = (1 << ((zz) & 31));
        b[i++] |= (j >> 24);
        b[i++] |= (j >> 16);
        b[i++] |= (j >> 8);
        b[i] |= j;
    }

    public void iput(int i, int j){
        //i *= 4; j *= 4;
        i <<= 2; j <<= 2;
        b[i++] = b[j++];
        b[i++] = b[j++];
        b[i++] = b[j++];
        b[i] = b[j];
    }

    public void fswap(int zz1, int zz2){
	//zz1 *= 4;
        zz1 <<= 2;
        byte b1 = b[zz1], b2 = b[zz1+1], b3=b[zz1+2], b4=b[zz1+3];
        //zz2 *= 4;
        zz2 <<= 2;
        b[zz1] = b[zz2]; b[zz1+1] = b[zz2 + 1]; 
        b[zz1+2] = b[zz2 + 2]; b[zz1+3] = b[zz2+3];
        b[zz2] = b1; b[zz2+1] = b2; b[zz2+2] = b3; b[zz2+3] = b4;
    }

    public void fvswap(int yyp1, int yyp2, int yyn){
        //int zz1, zz2;
        //yyp1 *= 4; yyp2 *= 4;
        yyp1 <<= 2; yyp2 <<=2;
        byte b1, b2, b3, b4;
        while (yyn > 0) {
            //zz1 = yyp1 * 4; zz2 = yyp2 * 4;
            b1 = b[yyp1]; b2 = b[yyp1+1]; b3=b[yyp1+2]; b4=b[yyp1+3]; 
            b[yyp1] = b[yyp2]; b[yyp1+1] = b[yyp2 + 1]; 
            b[yyp1+2] = b[yyp2 + 2]; b[yyp1+3] = b[yyp2+3];
            b[yyp2] = b1; b[yyp2+1] = b2; b[yyp2+2] = b3; b[yyp2+3] = b4;      
            yyp1 += 4; yyp2 += 4; yyn--;
        } 
    }

    public void nullify(int length){
        length <<= 2;
        for(int i = 0; i < length; i++)
            b[i] = 0;
    }

    public void lenSET(int max, int[] ftab){
        for(int a = 0; a < max; a++){
            int zz = ftab[a];
            int i = (zz >> 5) << 2;
            int j = (1 << ((zz) & 31));
            b[i++] |= (j >> 24);
            b[i++] |= (j >> 16);
            b[i++] |= (j >> 8);
            b[i] |= j;
	}
    }

    public void complexPut(int nblock, byte[] eclass8, int[] ftab){
        int i,j,k;
        for (i = 0; i < nblock; i++) {
            j = eclass8[i] & 0xff;//eclass8[i] < 0? eclass8[i] & 0xff: eclass8[i];
            k = ftab[j] - 1;
            //ftab[j] = k;
            ftab[j] = k;
            //fmap[k] = i;
            //fmap.put(k, i);
            //_fmap.putInt(k * 4, i);
            //put(k, i);
            k <<= 2;
            b[k++] = (byte)(i>> 24);
            b[k++] = (byte)(i>> 16);
            b[k++] = (byte)(i>>8);
            b[k] = (byte)i;
        }
    }

    public void setClear(int nblock){
        int i, j;
        for (int a = 0; a < 32; a++) { 
           int nib = nblock + 2 * a;
           //bhtab.SET(nblock + 2*i);
           i = (nblock >> 5) << 2;
           //int  j =       (((b[i] & 0xff) << 24) | 
	   //      ((b[i+1] & 0xff)<<16)| 
	   //      ((b[i+2] & 0xff)<<8)|
	   //	(b[i+3] & 0xff));
           j = (1 << ((nblock) & 31));
           b[i++] |= (j >> 24);
           b[i++] |= (j >> 16);
           b[i++] |= (j >> 8);
           b[i] |= j;
           nib+=1;
           //bhtab.SET(nib); bhtab.CLEAR(nib + 1);
           i = (nib >> 5) << 2;
           j = ~(1 << ((nib) & 31));
           b[i++] &= (j >> 24);
           b[i++] &= (j>> 16);
           b[i++] &= (j>>8);
           b[i] &= j;
        }
    }

}