package org.jythonx.bzip2;


public class IntViewSlice extends IntView{
    int start;
    IntViewSlice(byte[] b, int start){ super(b); this.start = start; }

    public int get(int i){
        i = (i * 4) + start;
        return ((b[i] & 0xff) << 24) | 
               ((b[i+1] & 0xff)<<16)| 
	       ((b[i+2] & 0xff)<<8)|
	       (b[i+3] & 0xff);
    }

    public long getUInt32(int i){
        i = (i*4) + start;
        return (((long)(b[i] & 0xff) << 24)|
	              ((b[i+1] & 0xff) << 16)|
	              ((b[i+2] & 0xff) << 8)|
	               (b[i+3] & 0xff));

	//(((long)((byte)(i >> 24)) & 0xff) << 24)
	//          |
	//  (((long)((byte)(i >> 16)) & 0xff) << 16)
	//          |
	//  (((long)((byte)(i >> 8)) & 0xff) << 8)
	//          |
	//  (long)((byte)i) & 0xff;

    }

    public void put(int i, int j){
        i =(i*4) + start;
        b[i] = (byte)(j >> 24);
        b[i+1] = (byte)(j>> 16);
        b[i+2] = (byte)(j>>8);
        b[i+3] = (byte)j;
    }

    public void iput(int i, int j){
        i = (i*4) + start; j = (j*4) + start;
        //byte b0 = b[j], b1 = b[j+1], b2 = b[j+2], b3 = b[j+3];
        //b[i] = b0; b[i+1] = b1; b[i+2] = b2; b[i+3] = b3;
        //System.arraycopy(b, i, b, j, 4);
        b[i] = b[j];
        b[i+1] = b[j+1];
        b[i+2] = b[j+2];
        b[i+3] = b[j+3];
    }



    public int capacity(){ return (b.length - start)/4; }

    public boolean ISSET(int zz){
        //ISSET_BH(zz)  (bhtab[(zz) >> 5] & (1 << ((zz) & 31)))
        int zz2 = ((zz >> 5) * 4) + start;
        return ((((b[zz2] & 0xff) << 24) | ((b[zz2+1] & 0xff)<<16)| 
		((b[zz2+2] & 0xff)<<8)| (b[zz2+3] & 0xff)) &
	        (1 << ((zz) & 31))) != 0;
    }

    public void SET(int zz){
        //SET_BH(zz)  bhtab[(zz) >> 5] |= (1 << ((zz) & 31))
        int i = ((zz>>5) * 4) + start;
        //int j = ((b[i] & 0xff) << 24) | 
	//((b[i+1] & 0xff)<<16)| 
	//       ((b[i+2] & 0xff)<<8)|
	//       (b[i+3] & 0xff);
		//j |= (1 << ((zz) & 31));
        //b[i] = (byte)(j >> 24);
        //b[i+1] = (byte)(j>> 16);
        //b[i+2] = (byte)(j>>8);
        //b[i+3] = (byte)j;

        int j = (1 << ((zz) & 31));
        b[i] |= (byte)(j >> 24);
        b[i+1] |= (byte)(j>> 16);
        b[i+2] |= (byte)(j>>8);
        b[i+3] |= (byte)j;
    }

    public void CLEAR(int zz){
        //CLEAR_BH(zz)  bhtab[(zz) >> 5] &= ~(1 << ((zz) & 31))
        int i = ((zz >> 5) * 4) + start;
        int j = ~(1 << ((zz) & 31));
        b[i] &= (byte)(j >> 24);
        b[i+1] &= (byte)(j>> 16);
        b[i+2] &= (byte)(j>>8);
        b[i+3] &= (byte)j;

    }


    public void fswap(int zz1, int zz2){
	zz1 =  (zz1 * 4) + start;
        //int zz1_1 = zz1 + 1, zz1_2 = zz1 + 2, zz1_3 = zz1 + 3;
        //System.arraycopy(b, zz1, sarray, 0, 4);
        byte b1 = b[zz1], b2 = b[zz1+1], b3=b[zz1+2], b4=b[zz1+3];
        zz2 = (zz2 *4) + start;
        b[zz1] = b[zz2]; b[zz1+1] = b[zz2 + 1]; 
        b[zz1+2] = b[zz2 + 2]; b[zz1+3] = b[zz2+3];

        b[zz2] = b1; b[zz2+1] = b2; b[zz2+2] = b3; b[zz2+3] = b4;
        //System.arraycopy(b, zz2, b, zz1, 4);
	// System.arraycopy(sarray, 0, b, zz2, 4);
        //int zz2_1 = zz2 + 1, zz2_2 = zz2 + 2, zz2_3 = zz2 + 3;
        //byte t1 = b[zz1], t2 = b[zz1_1], t3 = b[zz1_2], t4 = b[zz1_3];
        //b[zz1] = b[zz2]; b[zz1_1] = b[zz2_1]; 
        //b[zz1_2] = b[zz2_2]; b[zz1_3] = b[zz2_3];
        //b[zz2] = t1; b[zz2_1] = t2; b[zz2_2] = t3; b[zz2_3] = t4;
    }

    public void fvswap(int yyp1, int yyp2, int yyn){
        int zz1, zz2;
        byte b1, b2, b3, b4;
        while (yyn > 0) {
            zz1 = (yyp1 * 4) + start; zz2 = (yyp2 * 4) + start;
            b1 = b[zz1]; b2 = b[zz1+1]; b3=b[zz1+2]; b4=b[zz1+3]; 
            b[zz1] = b[zz2]; b[zz1+1] = b[zz2 + 1]; 
            b[zz1+2] = b[zz2 + 2]; b[zz1+3] = b[zz2+3];
            b[zz2] = b1; b[zz2+1] = b2; b[zz2+2] = b3; b[zz2+3] = b4;      
	    //fswap(fmap[yyp1], fmap[yyp2]);  
            //fmap.fswap(yyp1, yyp2);
	    //int zztmp = fmap.get(yyp1);//fmap[yyp1];
            //fmap[yyp1] = fmap[yyp2];
            //fmap.put(yyp1, fmap.get(yyp2));
            //fmap[yyp2] = zztmp;
            //fmap.put(yyp2, zztmp);            
            yyp1++; yyp2++; yyn--;          
        } 
    }

    public void nullify(int start, int length){
        start = (start+4) + this.start;
        length = (length * 4);
        int stop = start + length;
        for(; start < stop; start++)
            b[start] = 0;
    }

    

}