package org.jythonx.bzip2;

import java.nio.*;
import java.nio.channels.*;
import java.io.*;
import java.util.*;

public class bzip2 implements BZConstants{


    static final String PATH_SEP = System.getProperty("path.separator");
    static final int SM_I2O = 1;
    static final int SM_F2O = 2;
    static final int SM_F2F = 3;

    /*-- operation modes --*/
    static final int OM_Z = 1;
    static final int OM_UNZ = 2;
    static final int OM_TEST =3;
    static final int FILE_NAME_LEN =1034;
    static int BZ_N_SUFFIX_PAIRS = 4;

    StringBuilder   inName = new StringBuilder(FILE_NAME_LEN);
    StringBuilder  outName = new StringBuilder(FILE_NAME_LEN);
    StringBuilder progNameReally = new StringBuilder(FILE_NAME_LEN);
    char[]  tmpName = new char[FILE_NAME_LEN];
    public boolean smallMode = false;
    public boolean noisy = false;
    public String progName = "";
    public boolean forceOverwrite = false;
    public int exitValue;
    public int verbosity;
    public int blockSize100k;
    public int workFactor;
    public int opMode;
    public int srcMode;
    public boolean keepInputFiles;
    public boolean testFailsExist;
    public boolean unzFailsExist;
    int numFilesProcessed;
    int numFileNames;
    int longestFileName;
    boolean deleteOutputOnInterrupt;
    WritableByteChannel outputHandleJustInCase;
    ReadableByteChannel stdin = Channels.newChannel(System.in);
    WritableByteChannel stdout = Channels.newChannel(System.out);
    Cell argList;
    Cell aa;

    public static void main(String ... args) throws Exception{
	new bzip2(args);
    }

    public bzip2(String[] args) throws IOException{
        //long start = System.currentTimeMillis();
        String[] argv = new String[args.length + 1];
        argv[0] = "bzip2";
        System.arraycopy(args, 0, argv, 1, args.length);
        run(argv);
        //long end = System.currentTimeMillis();
        //System.out.println("TIME: " + (end - start));
    }

    public void compressStream (ReadableByteChannel stream, WritableByteChannel zStream) throws IOException{
	//BZFILE* bzf = NULL;
        bzFile bzf = null;
        //UChar   ibuf[5000];
        //byte[] ibuf = new byte[5000];
        ByteBuffer ibuf = ByteBuffer.wrap(new byte[5000]);
        ibuf.position(0);
        //Int32   nIbuf;
        int nIbuf;
        long  nbytes_in_lo32=0, nbytes_in_hi32 =0;
        long  nbytes_out_lo32=0, nbytes_out_hi32 = 0;
        int[]   bzerr = new int[1];
        int[]  bzerr_dummy = new int[1];
        int ret;

        //SET_BINARY_MODE(stream);
	//SET_BINARY_MODE(zStream);

	//if (ferror(stream)) goto errhandler_io;
	//if (ferror(zStream)) goto errhandler_io;

        errhandler:{
	bzf = BZLib.BZ2_bzWriteOpen ( bzerr, zStream, 
                           blockSize100k, verbosity, workFactor );   
        if (bzerr[0] != BZ_OK) break errhandler;

	//if (verbosity >= 2) fprintf ( stderr, "\n" );
       while (true) {

           //if (myfeof(stream)) break;
           //nIbuf = stream.read(ibuf);
           nIbuf = stream.read(ibuf);
           if(nIbuf < 0){
               break;
           }
           ibuf.position(0);
           ibuf.limit(nIbuf);
           //nIbuf = fread ( ibuf, sizeof(UChar), 5000, stream );
           //if (ferror(stream)) goto errhandler_io;
           if (nIbuf > 0){ 
               BZLib.BZ2_bzWrite (bzerr, bzf, ibuf, nIbuf );
           }
          ibuf.position(0); ibuf.limit(ibuf.capacity());
          if (bzerr[0] != BZ_OK) break errhandler;

      }

       long[] nbytes = new long[4];
       /** BZ2_bzWriteClose64 ( &bzerr, bzf, 0, 
                        &nbytes_in_lo32, &nbytes_in_hi32,
                        &nbytes_out_lo32, &nbytes_out_hi32 ); */
       BZLib.BZ2_bzWriteClose64(bzerr, bzf, 0, nbytes);
       nbytes_in_lo32 = nbytes[0];
       nbytes_in_hi32 = nbytes[1];
       nbytes_out_lo32 = nbytes[2];
       nbytes_out_hi32 = nbytes[3];
       if (bzerr[0] != BZ_OK) break errhandler;

       //if (ferror(zStream)) goto errhandler_io;
       //ret = fflush ( zStream );
      //if (ret == EOF) goto errhandler_io;
      //if (zStream != stdout) {
       // Int32 fd = fileno ( zStream );
       // if (fd < 0) goto errhandler_io;
      // applySavedFileAttrToOutputFile ( fd );
       // ret = fclose ( zStream );
       // outputHandleJustInCase = NULL;
       // if (ret == EOF) goto errhandler_io;
      //}
      if(zStream != stdout)
          zStream.close();
      outputHandleJustInCase = null;
      //if (ferror(stream)) goto errhandler_io;
      //ret = fclose ( stream );
      if(stream != stdin)
          stream.close();
      //if (ret == EOF) goto errhandler_io;

   /** if (verbosity >= 1) {
      if (nbytes_in_lo32 == 0 && nbytes_in_hi32 == 0) {
	  //fprintf ( stderr, " no data compressed.\n");
          System.err.println(" no data compressed.\n");
      } else {
	 char[] buf_nin = new char[32], buf_nout  = new char[32];
	 UInt64 nbytes_in,   nbytes_out;
	 double nbytes_in_d, nbytes_out_d;
	 uInt64_from_UInt32s ( &nbytes_in, 
			       nbytes_in_lo32, nbytes_in_hi32 );
	 uInt64_from_UInt32s ( &nbytes_out, 
			       nbytes_out_lo32, nbytes_out_hi32 );
	 nbytes_in_d  = uInt64_to_double ( &nbytes_in );
	 nbytes_out_d = uInt64_to_double ( &nbytes_out );
	 uInt64_toAscii ( buf_nin, &nbytes_in );
	 uInt64_toAscii ( buf_nout, &nbytes_out );
	 fprintf ( stderr, "%6.3f:1, %6.3f bits/byte, "
		   "%5.2f%% saved, %s in, %s out.\n",
		   nbytes_in_d / nbytes_out_d,
		   (8.0 * nbytes_out_d) / nbytes_in_d,
		   100.0 * (1.0 - nbytes_out_d / nbytes_in_d),
		   buf_nin,
		   buf_nout
		 );
      }
      } */

       return;
    }
   //errhandler:
	long[] i_o = { nbytes_in_lo32, nbytes_in_hi32, nbytes_out_lo32, nbytes_out_hi32};
	BZLib.BZ2_bzWriteClose64 ( bzerr_dummy, bzf, 1,  i_o);
        switch (bzerr[0]) {
        case BZ_CONFIG_ERROR:
          configError(); break;
        case BZ_MEM_ERROR:
          outOfMemory (); break;
        case BZ_IO_ERROR:
           errhandler_io:
           ioError(); break;
        default:
           panic ( "compress:unexpected error" );
        }

        panic ( "compress:end" ); 
       /*notreached*/
    }


    public boolean uncompressStream (ReadableByteChannel zStream, WritableByteChannel stream ) throws IOException
{
        bzFile bzf = null;
        int[]   bzerr = new int[1];
        int[] bzerr_dummy = new int[1];
        int ret, nread, streamNo, i;
        ByteBuffer   obuf = ByteBuffer.allocate(5000);//new byte[5000];
        byte[]   unused = new byte[BZ_MAX_UNUSED];
        long[]   nUnused = new long[1];
        ByteBuffer[]   unusedTmpV = new ByteBuffer[1];
        ByteBuffer[]  unusedTmp = new ByteBuffer[1];

        nUnused[0] = 0;
        streamNo = 0;

       //SET_BINARY_MODE(stream);
       //SET_BINARY_MODE(zStream);

       //if (ferror(stream)) goto errhandler_io;
       //if (ferror(zStream)) goto errhandler_io;
       errhandler:{
           trycat:{
          closeok:{
     while (true) {

         bzf = BZLib.BZ2_bzReadOpen ( 
                  bzerr, zStream, verbosity, 
                  smallMode, unused, nUnused
                );
         if (bzf == null || bzerr[0] != BZ_OK) break errhandler;
         streamNo++;

         while (bzerr[0] == BZ_OK) {
	     obuf.clear();
             nread = BZLib.BZ2_bzRead ( bzerr, bzf, obuf, 5000 );
             if (bzerr[0] == BZ_DATA_ERROR_MAGIC) break trycat;
             if ((bzerr[0] == BZ_OK || bzerr[0] == BZ_STREAM_END) && nread > 0){
	         //fwrite ( obuf, sizeof(UChar), nread, stream );
                if(obuf.position() != 0)
                    obuf.flip();
                 try{
                     int amount = stream.write(obuf);
                     obuf.clear();
                 } catch(IOException x){ 
		     //break errhandler_io; 
                     ioError();
                     panic ( "decompress:end" );
                    return true;
                 }
             }
             //if (ferror(stream)) break errhandler_io;
          }
          if (bzerr[0] != BZ_STREAM_END) break errhandler;

          BZLib.BZ2_bzReadGetUnused ( bzerr, bzf, unusedTmpV, nUnused );
          if (bzerr[0] != BZ_OK) panic ( "decompress:bzReadGetUnused" );

          unusedTmp = unusedTmpV;
          for (i = 0; i < nUnused[0]; i++) unused[i] = unusedTmp[0].get(i);

          BZLib.BZ2_bzReadClose (bzerr, bzf );
          if (bzerr[0] != BZ_OK) panic ( "decompress:bzReadGetUnused" );

          if(nUnused[0] == 0) break;
          //if (nUnused == 0 && myfeof(zStream)) break;
       }

       }//closeok:
	   //if (ferror(zStream)) goto errhandler_io;
	   //if (stream != stdout) {
	   //Int32 fd = fileno ( stream );
	   //if (fd < 0) goto errhandler_io;
	   // applySavedFileAttrToOutputFile ( fd );
	   // }
	   //ret = fclose ( zStream );
	   //if (ret == EOF) goto errhandler_io;

	   //if (ferror(stream)) goto errhandler_io;
	   //ret = fflush ( stream );
	   //if (ret != 0) goto errhandler_io;
	   // if (stream != stdout) {
	   //ret = fclose ( stream );
	   //outputHandleJustInCase = NULL;
	   //if (ret == EOF) goto errhandler_io;
	   //}
	   //outputHandleJustInCase = NULL;
	   //if (verbosity >= 2) fprintf ( stderr, "\n    " );
          zStream.close();
          stream.close();
          return true;
       }//trycat: 
       if (forceOverwrite) {
           if(!(zStream instanceof FileChannel))
               throw new IOException("Can't force overwrite, no way to rewind stream: " + zStream);
           //rewind(zStream);
           ((FileChannel)zStream).position(0);
          while (true) {
	     //if (myfeof(zStream)) break;
	     //n read = fread ( obuf, sizeof(UChar), 5000, zStream );
             obuf.clear();
	     nread = zStream.read(obuf);
             if(nread < 0) break;
             obuf.flip();
             stream.write(obuf);
             obuf.clear();
      	    //if (ferror(zStream)) goto errhandler_io;
      	    //if (nread > 0) fwrite ( obuf, sizeof(UChar), nread, stream );
      	    //if (ferror(stream)) goto errhandler_io;
         }
         //goto closeok;
         stream.close();
         return true;
       }
  
      }//errhandler:
      BZLib.BZ2_bzReadClose (bzerr_dummy, bzf);
      switch (bzerr[0]) {
         case BZ_CONFIG_ERROR:
            configError(); break;
         case BZ_IO_ERROR:
	     //errhandler_io:
            ioError(); break;
         case BZ_DATA_ERROR:
            crcError();
         case BZ_MEM_ERROR:
            outOfMemory();
         case BZ_UNEXPECTED_EOF:
            compressedStreamEOF();
         case BZ_DATA_ERROR_MAGIC:
	  //if (zStream != stdin) fclose(zStream);
	  //if (stream != stdout) fclose(stream);
	  //if (streamNo == 1) {
	  //return false;
	  //} else {
	  //if (noisy)
	  //fprintf ( stderr, 
	  //          "\n%s: %s: trailing garbage after EOF ignored\n",
	  //          progName, inName );
	  //return true;       
	  //}
             if(zStream != stdin)
                zStream.close();
             if(stream != stdout)
                 stream.close();
             return true;
          default:
             panic ( "decompress:unexpected error" );
       }

       panic ( "decompress:end" );
       return true; /*notreached*/
    }

    /*---------------------------------------------*/
    void panic (String s )
    {
        System.err.println(
                 "\n" + progName + ": PANIC -- internal consistency error:\n" +
                "\t" + s + "\n" +
                "\tThis is a BUG.");
        showFileNames();
       cleanUpAndFail( 3 );
    }


    /*---------------------------------------------*/
   void crcError ()
   {
       System.err.println("\n" + progName + ": Data integrity error when decompressing.");
       showFileNames();
       cadvise();
       cleanUpAndFail( 2 );
   }

   /*---------------------------------------------*/
   void cadvise ()
   {
        if (noisy){
           System.err.println(
               "\nIt is possible that the compressed file(s) have become corrupted.\n" +
               "You can use the -tvv option to test integrity of such files.\n\n" + 
               "You can use the `bzip2recover' program to attempt to recover\n" +
               "data from undamaged sections of corrupted files.\n");
        }
    }

   /*---------------------------------------------*/
   void outOfMemory ()
   {
       System.err.println("\n" + progName + ": couldn't allocate enough memory");
       showFileNames();
       cleanUpAndFail(1);
    }


    void showFileNames ()
    {
        if (noisy){
            System.err.println("\tInput file = " + inName + ", output file = " + outName);
        }
    }

    void ioError ()
    {
        System.err.println(
                 "\n" + progName + ": I/O or other error, bailing out.  " +
                 "Possible reason follows.");
        //perror ( progName );
        System.err.println(progName);
        showFileNames();
        cleanUpAndFail( 1 );
    }

    void configError ()
    {
        System.err.println("bzip2: I'm not configured correctly for this platform!");
        setExit(3);
        System.exit(exitValue);
        //exit(exitValue);
    }

    /*---------------------------------------------*/
    void compressedStreamEOF ()
    {
      if (noisy) {
          System.err.println(
	          "\n" + progName + ": Compressed file ends unexpectedly;\n\t" +
	          "perhaps it is corrupted?  *Possible* reason follows.");
          //perror ( progName );
          System.err.println(progName);
          showFileNames();
          cadvise();
      }
      cleanUpAndFail( 2 );
    }

    void setExit (int v )
    {
       if (v > exitValue) exitValue = v;
    }

    void exit(int v){ System.exit(v); }

    void cleanUpAndFail ( int ec )
    {
       /** int      retVal;
      struct MY_STAT statBuf;

      if ( srcMode == SM_F2F 
           && opMode != OM_TEST
           && deleteOutputOnInterrupt ) { */

         /* Check whether input file still exists.  Delete output file
            only if input exists to avoid loss of data.  Joerg Prante, 5
            January 2002.  (JRS 06-Jan-2002: other changes in 1.0.2 mean
            this is less likely to happen.  But to be ultra-paranoid, we
            do the check anyway.)  */
         /** retVal = MY_STAT ( inName, &statBuf );
         if (retVal == 0) {
            if (noisy)
               fprintf ( stderr, 
                         "%s: Deleting output file %s, if it exists.\n",
                         progName, outName );
            if (outputHandleJustInCase != NULL)
               fclose ( outputHandleJustInCase );
            retVal = remove ( outName );
            if (retVal != 0)
               fprintf ( stderr,
                         "%s: WARNING: deletion of output file "
                         "(apparently) failed.\n",
                         progName );
         } else {
            fprintf ( stderr,
                      "%s: WARNING: deletion of output file suppressed\n",
                       progName );
            fprintf ( stderr,
                      "%s:    since input file no longer exists.  Output file\n",
                      progName );
            fprintf ( stderr,
                      "%s:    `%s' may be incomplete.\n",
                      progName, outName );
            fprintf ( stderr, 
                      "%s:    I suggest doing an integrity test (bzip2 -tv)"
                      " of it.\n",
                      progName );
         }
      }

      if (noisy && numFileNames > 0 && numFilesProcessed < numFileNames) {
         fprintf ( stderr, 
                   "%s: WARNING: some files have not been processed:\n"
                   "%s:    %d specified on command line, %d not processed yet.\n\n",
                   progName, progName,
                   numFileNames, numFileNames - numFilesProcessed );
      }
      setExit(ec);
      exit(exitValue); */
       setExit(ec);
       System.exit(exitValue);
   }


    /*---------------------------------------------*/
   static void license (){
        System.err.println(
        "bzip2, a block-sorting file compressor.  " +
        "Version " + BZLib.BZ2_bzlibVersion()+ ".\n" +
        "   \n" +
        "   Copyright (C) 1996-2006 by Julian Seward.\n" +
        "   \n" +
        "   This program is free software; you can redistribute it and/or modify\n" +
        "   it under the terms set out in the LICENSE file, which is included\n" +
       "   in the bzip2-1.0.4 source distribution.\n" +
       "   \n" +
       "   This program is distributed in the hope that it will be useful,\n" +
       "   but WITHOUT ANY WARRANTY; without even the implied warranty of\n" +
       "   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n" +
       "   LICENSE file for more details.\n" +
       "   \n"
      );
   }


    /*---------------------------------------------*/
   static void usage (String fullProgName ){
       System.err.println(
         "bzip2, a block-sorting file compressor.  " +
         "Version " + BZLib.BZ2_bzlibVersion()+ ".\n" +
         "\n   usage: " + fullProgName + " [flags and input files in any order]\n" +
         "\n" + 
         "   -h --help           print this message\n" +
         "   -d --decompress     force decompression\n" +
         "   -z --compress       force compression\n" +
         "   -k --keep           keep (don't delete) input files\n" +
         "   -f --force          overwrite existing output files\n" +
         "   -t --test           test compressed file integrity\n" +
         "   -c --stdout         output to standard out\n" +
         "   -q --quiet          suppress noncritical error messages\n" +
         "   -v --verbose        be verbose (a 2nd -v gives more)\n" +
         "   -L --license        display software version & license\n" +
         "   -V --version        display software version & license\n" +
         "   -s --small          use less memory (at most 2500k)\n" +
         "   -1 .. -9            set block size to 100k .. 900k\n" +
         "   --fast              alias for -1\n" +
         "   --best              alias for -9\n" +
         "\n" +
         "   If invoked as `bzip2', default action is to compress.\n" +
         "              as `bunzip2',  default action is to decompress.\n" +
         "              as `bzcat', default action is to decompress to stdout.\n" +
         "\n" +
         "   If no file names are given, bzip2 compresses or decompresses\n" +
         "   from standard input to standard output.  You can combine\n" +
         "   short flags, so `-v -4' means the same as -v4 or -4v, &c.\n"
      );
    }

    void redundant (String flag )
   {
        System.err.println(progName + ": " + flag + " is redundant in versions 0.9.5 and above");
   }

    /*---------------------------------------------*/ 
    void testf (String name ) throws IOException
   {
       ReadableByteChannel inStr = null;
       boolean allOK;
       //struct MY_STAT statBuf;


       deleteOutputOnInterrupt = false;

      if (name == null && srcMode != SM_I2O)
          panic ( "testf: bad modes\n" );
      File statBuf = new File(name);
      StringBuilder inName = new StringBuilder(this.inName);

       //copyFileName ( outName, "(none)" );
       outName = new StringBuilder("(none)");
       switch (srcMode) {
          case SM_I2O: 
	      //copyFileName ( inName, "(stdin)" ); 
	      inName = new StringBuilder("(stdin)");
              break;
          case SM_F2F: 
              //copyFileName ( inName, name ); 
              inName = new StringBuilder(name);
              break;
          case SM_F2O: 
              //copyFileName ( inName, name ); 
              inName = new StringBuilder(name);
              break;
       }

       if ( srcMode != SM_I2O && containsDubiousChars ( inName.toString() ) ) {
           if (noisy){
	       //fprintf ( stderr, "%s: There are no files matching `%s'.\n",
	       //   progName, inName );
               System.err.println(progName + ": There are no files matching '" + inName + "'");
           }
           setExit(1);
           return;
       }
       if ( srcMode != SM_I2O && !(new File(inName.toString()).exists())){//!fileExists ( inName ) ) {
           //fprintf ( stderr, "%s: Can't open input %s: %s.\n",
           //       progName, inName, strerror(errno) );
           System.err.println(progName + ": Can't open input " + inName);
           setExit(1);
          return;
       }
       if ( srcMode != SM_I2O ) {
           //MY_STAT(inName, &statBuf);
           //if ( MY_S_ISDIR(statBuf.st_mode) ) {
           if(new File(inName.toString()).isDirectory()){
	      //fprintf( stderr,
	      //     "%s: Input file %s is a directory.\n",
	       //     progName,inName);
	      System.err.println(progName + ": Input file " + inName + " is a directory");
              setExit(1);
             return;
           }
       }

       switch ( srcMode ) {

          case SM_I2O:
	      //if ( isatty ( fileno ( stdin ) ) ) {
	      //fprintf ( stderr,
	      //          "%s: I won't read compressed data from a terminal.\n",
	      //          progName );
	      //fprintf ( stderr, "%s: For help, type: `%s --help'.\n",
	      //                  progName, progName );
	      //setExit(1);
	      //return;
	      //};
	      inStr = stdin;
              break;
          case SM_F2O: case SM_F2F:
              try{
	         inStr = new FileInputStream(inName.toString()).getChannel();
                 //fopen  ( inName, "rb" );
              } catch(IOException x){}
              if ( inStr == null) {
	         //fprintf ( stderr, "%s: Can't open input file %s:%s.\n",
	         //       progName, inName, strerror(errno) );
	        System.err.println(progName + ": Can't open input file " + inName);
                setExit(1);
                return;
              };
              break;

          default:
              panic ( "testf: bad srcMode" );
              break;
       }

       if (verbosity >= 1) {
           //fprintf ( stderr, "  %s: ", inName );
           System.err.println(inName + ": ");
           pad ( inName );
           //fflush ( stderr );
           System.err.flush();
       }

       /*--- Now the input handle is sane.  Do the Biz. ---*/
       outputHandleJustInCase = null ;
       allOK = testStream ( inStr );

       if (allOK && verbosity >= 1) {
           //fprintf ( stderr, "ok\n" );
           System.err.println("ok");
       }
       if (!allOK) testFailsExist = true;
    }

    int run(String argv[] ) throws IOException{
        int  i, j;
        StringBuilder tmp;
        boolean   decode;
        /*-- Initialise --*/
        outputHandleJustInCase  = null;
        smallMode               = false;
        keepInputFiles          = false;
        forceOverwrite          = false;
        noisy                   = true;
        verbosity               = 0;
        blockSize100k           = 9;
        testFailsExist          = false;
        unzFailsExist           = false;
        numFileNames            = 0;
        numFilesProcessed       = 0;
        workFactor              = 30;
        deleteOutputOnInterrupt = false;
        exitValue               = 0;
        i = j = 0; /* avoid bogus warning from egcs-1.1.X */

        //copyFileName ( inName,  "(none)" );
        inName = new StringBuilder("(none)");
        outName = new StringBuilder("(none)");
        //copyFileName ( outName, "(none)" );

        //copyFileName ( progNameReally, argv[0] );
        progNameReally = new StringBuilder(argv[0]);
        progName = progNameReally.toString();
        int ti = 0;
        for(tmp = progNameReally; ti < tmp.length(); ti++)
           if(String.valueOf(tmp.charAt(ti)).equals(PATH_SEP)) progName = tmp.substring(ti, tmp.length());
        //for (tmp = progNameReally[0]; *tmp != '\0'; tmp++)
        // if (*tmp == PATH_SEP) progName = tmp + 1;


        /*-- Copy flags from env var BZIP2, and 
            expand filename wildcards in arg list.
        --*/
       argList = null;
       addFlagsFromEnvVar ( argList,  "BZIP2" );
       addFlagsFromEnvVar ( argList,  "BZIP" );
       for (i = 1; i <= argv.length-1; i++)
          argList = APPEND_FILESPEC(argList, argv[i]);

       /*-- Find the length of the longest filename --*/
       longestFileName = 7;
       numFileNames    = 0;
       decode          = true;
       for (aa = argList; aa != null; aa = aa.link) {
         if (ISFLAG("--")) { decode = false; continue; }
         if (aa.name.charAt(0) == '-' && decode) continue;
         numFileNames++;
         if (longestFileName < aa.name.length() )
	     longestFileName = aa.name.length();
       }

       /*-- Determine source modes; flag handling may change this too. --*/
       if (numFileNames == 0)
           srcMode = SM_I2O; 
       else srcMode = SM_F2F;


       /*-- Determine what to do (compress/uncompress/test/cat). --*/
       /*-- Note that subsequent flag handling may change this. --*/
       opMode = OM_Z;

       //if ( (strstr ( progName, "unzip" ) != 0) ||
       //   (strstr ( progName, "UNZIP" ) != 0) )
       if(progName.contains("unzip") || progName.contains("UNZIP"))
          opMode = OM_UNZ;

       if ( //(strstr ( progName, "z2cat" ) != 0) ||
           //(strstr ( progName, "Z2CAT" ) != 0) ||
           // (strstr ( progName, "zcat" ) != 0)  ||
            //(strstr ( progName, "ZCAT" ) != 0) )  {
           progName.contains("z2cat") || progName.contains("Z2CAT") ||
           progName.contains("zcat") || progName.contains("ZCAT"))
       {
          opMode = OM_UNZ;
          srcMode = (numFileNames == 0) ? SM_I2O : SM_F2O;
       }


       /*-- Look at the flags. --*/
       for (aa = argList; aa != null; aa = aa.link) {
           if (ISFLAG("--")) break;
           if (aa.name.charAt(0) == '-' && aa.name.charAt(1) != '-') {
	   for (j = 1; j < aa.name.length(); j++) {
	       switch (aa.name.charAt(j)) {
                   case 'c': srcMode          = SM_F2O; break;
                   case 'd': opMode           = OM_UNZ; break;
                   case 'z': opMode           = OM_Z; break;
                   case 'f': forceOverwrite   = true; break;
                   case 't': opMode           = OM_TEST; break;
                   case 'k': keepInputFiles   = true; break;
                   case 's': smallMode        = true; break;
                   case 'q': noisy            = false; break;
                   case '1': blockSize100k    = 1; break;
                   case '2': blockSize100k    = 2; break;
                   case '3': blockSize100k    = 3; break;
                   case '4': blockSize100k    = 4; break;
                   case '5': blockSize100k    = 5; break;
                   case '6': blockSize100k    = 6; break;
                   case '7': blockSize100k    = 7; break;
                   case '8': blockSize100k    = 8; break;
                   case '9': blockSize100k    = 9; break;
                   case 'V':
                   case 'L': license();            break;
                   case 'v': verbosity++; break;
                   case 'h': usage ( progName );
                             exit ( 0 );
                             break;
	          default:  
                        //fprintf ( stderr, "%s: Bad flag `%s'\n",
                        //           progName, aa.name );
		      System.err.println(progName + ": Bad flag `" + aa.name + "'");
                             usage ( progName );
                             exit ( 1 );
                             break;
                }
             }
          }
       }
   
       /*-- And again ... --*/
       for (aa = argList; aa != null; aa = aa.link) {
           if (ISFLAG("--")) break;
           if (ISFLAG("--stdout"))            srcMode          = SM_F2O;  else
           if (ISFLAG("--decompress"))        opMode           = OM_UNZ;  else
           if (ISFLAG("--compress"))          opMode           = OM_Z;    else
           if (ISFLAG("--force"))             forceOverwrite   = true;    else
           if (ISFLAG("--test"))              opMode           = OM_TEST; else
           if (ISFLAG("--keep"))              keepInputFiles   = true;    else
           if (ISFLAG("--small"))             smallMode        = true;    else
           if (ISFLAG("--quiet"))             noisy            = false;   else
           if (ISFLAG("--version"))           license();                  else
           if (ISFLAG("--license"))           license();                  else
           if (ISFLAG("--exponential"))       workFactor = 1;             else 
           if (ISFLAG("--repetitive-best"))   redundant(aa.name);        else
           if (ISFLAG("--repetitive-fast"))   redundant(aa.name);        else
           if (ISFLAG("--fast"))              blockSize100k = 1;          else
           if (ISFLAG("--best"))              blockSize100k = 9;          else
           if (ISFLAG("--verbose"))           verbosity++;                else
           if (ISFLAG("--help"))              { usage ( progName ); exit ( 0 ); }
           else
	     //if (strncmp ( aa.name, "--", 2) == 0) {
	     if(aa.name.equals("--")){
	         //fprintf ( stderr, "%s: Bad flag `%s'\n", progName, aa.name );
	         System.err.println(progName + ": Bad flag `" + aa.name + "'");
                 usage ( progName );
                 exit ( 1 );
             }
       }

       if (verbosity > 4) verbosity = 4;
       if (opMode == OM_Z && smallMode && blockSize100k > 2) 
           blockSize100k = 2;

       if (opMode == OM_TEST && srcMode == SM_F2O) {
           //fprintf ( stderr, "%s: -c and -t cannot be used together.\n",
           //       progName );
           System.err.println(progName + ":  -c and -t cannot be used together.");
           exit ( 1 );
       }

       if (srcMode == SM_F2O && numFileNames == 0)
          srcMode = SM_I2O;

       if (opMode != OM_Z) blockSize100k = 0;


       if (opMode == OM_Z) {
         if (srcMode == SM_I2O) {
            compress ( null );
         } else {
            decode = true;
            for (aa = argList; aa != null; aa = aa.link) {
               if (ISFLAG("--")) { decode = false; continue; }
               if (aa.name.charAt(0) == '-' && decode) continue;
               numFilesProcessed++;
               compress ( aa.name );
            }
         }
       } 
       else

       if (opMode == OM_UNZ) {
          unzFailsExist = false;
         if (srcMode == SM_I2O) {
             uncompress ( null );
         } else {
             decode = true;
             for (aa = argList; aa != null; aa = aa.link) {
                if (ISFLAG("--")) { decode = false; continue; }
                if (aa.name.charAt(0) == '-' && decode) continue;
                numFilesProcessed++;
                uncompress ( aa.name );
             }      
          }
          if (unzFailsExist) { 
             setExit(2); 
             exit(exitValue);
          }
       } 

      else {
          testFailsExist = false;
          if (srcMode == SM_I2O) {
             testf ( null );
          } else {
             decode = true;
             for (aa = argList; aa != null; aa = aa.link) {
	        if (ISFLAG("--")) { decode = false; continue; }
                if (aa.name.charAt(0) == '-' && decode) continue;
                numFilesProcessed++;
                testf ( aa.name );
	     }
          }
          if (testFailsExist && noisy) {
	      //fprintf ( stderr,
              // "\n"
	      //"You can use the `bzip2recover' program to attempt to recover\n"
              // "data from undamaged sections of corrupted files.\n\n"
	      //);
             setExit(2);
             exit(exitValue);
          }
       }
       return exitValue;
    }

    boolean ISFLAG(String s){
        return aa.name.equals(s);
    }

    static class Cell{
        String name;
        Cell link;
    }

    void addFlagsFromEnvVar (Cell argList, String varName ) {
        int i, j, k;
        String envbase, p;

        envbase = System.getenv(varName);
        if (envbase != null) {
            p = envbase;
            i = 0;
            int pi = 0;
            while (true) {
	       //if (p[i] == 0) break;
	       if(i == p.length()) break;
               pi += i;
               i = 0;
              //while (isspace((Int32)(p[0]))) p++;
              while(Character.isWhitespace(p.charAt(pi))) pi++;
              //while (p[i] != 0 && !isspace((Int32)(p[i]))) i++;
              while(i < (p.length() - pi) && !Character.isWhitespace(p.charAt(pi + i))) i++;
              if (i > 0) {
                  k = i; if (k > FILE_NAME_LEN-10) k = FILE_NAME_LEN-10;
                  for (j = 0; j < k; j++) tmpName[j] = p.charAt(pi + j);//p[j];
                 //tmpName[k] = 0;
                argList = APPEND_FLAG(argList, new String(tmpName, 0, k));
             }
          }
       }
    }

    Cell APPEND_FLAG(Cell root, String name){
        return snocString(root, name);
    }

    Cell APPEND_FILESPEC(Cell root, String name){
       return snocString(root, name);
    }

    /*---------------------------------------------*/
    Cell snocString (Cell root, String name )
    {
       if (root == null) {
          Cell tmp = new Cell();//mkCell();
          //tmp->name = (Char*) myMalloc ( 5 + strlen(name) );
          tmp.name = name;
          //strcpy ( tmp->name, name );
          return tmp;
       } else {
          Cell tmp = root;
          while (tmp.link != null) tmp = tmp.link;
          tmp.link = snocString ( tmp.link, name );
          return root;
       }
    }

    boolean containsDubiousChars (CharSequence name)
    {
        //#  if BZ_UNIX
      /* On unix, files can contain any characters and the file expansion
       * is performed by the shell.
       */
       //this is really questionable...
       if(System.getProperty("path.separator").equals(":")){
          return false;
          //#  else /* ! BZ_UNIX */
       }
       else{
       /* On non-unix (Win* platforms), wildcard characters are not allowed in 
        * filenames.
        */
         for(int i = 0; i < name.length(); i++)
	     if(name.charAt(i) == '?' || name.charAt(i) == '*') return true;
         //for (; *name != '\0'; name++)
         // if (*name == '?' || *name == '*') return true;
        return false;
       }
       //#  endif /* BZ_UNIX */
    }

 
    void pad (StringBuilder s )
    {
       int i;
       if (s.length() >= longestFileName ) return;
       for (i = 1; i <= longestFileName - s.length(); i++)
           System.err.print(" ");
           //fprintf ( stderr, " " );
    }

    //void copyFileName (StringBuffer to, Char* from ) 
    //{
    //if ( strlen(from) > FILE_NAME_LEN-10 )  {
    //fprintf (
    //   stderr,
    //   "bzip2: file name\n`%s'\n"
    //   "is suspiciously (more than %d chars) long.\n"
    //   "Try using a reasonable file name instead.  Sorry! :-)\n",
    //   from, FILE_NAME_LEN-10
    //);
    //setExit(1);
    //exit(exitValue);
    //}

    //strncpy(to,from,FILE_NAME_LEN-10);
    //to[FILE_NAME_LEN-10]='\0';
    //}

    /*---------------------------------------------*/
    boolean testStream (ReadableByteChannel zStream) throws IOException
    {
         bzFile bzf = null;
         int[] bzerr = new int[1];
         int[] bzerr_dummy = new int[1];
         int ret, nread, streamNo, i;
         ByteBuffer   obuf = ByteBuffer.allocate(5000);
         byte[]   unused = new byte[BZ_MAX_UNUSED];
         long[]   nUnused = new long[1];
         ByteBuffer[]   unusedTmpV = new ByteBuffer[1];
         ByteBuffer[]  unusedTmp = new ByteBuffer[1];

         nUnused = new long[]{0};
         streamNo = 0;

         //SET_BINARY_MODE(zStream);
         //if (ferror(zStream)) goto errhandler_io;
         errhandler:{
         while (true) {
       
             bzf = BZLib.BZ2_bzReadOpen ( 
	           bzerr, zStream, verbosity, 
                   smallMode, unused, nUnused
                );
             if (bzf == null || bzerr[0] != BZ_OK) break errhandler;
             streamNo++;

             while (bzerr[0] == BZ_OK) {
                 obuf.clear();
                 nread = BZLib.BZ2_bzRead ( bzerr, bzf, obuf, 5000 );
                if (bzerr[0] == BZ_DATA_ERROR_MAGIC) break errhandler;
             }
             if (bzerr[0] != BZ_STREAM_END) break errhandler;

             BZLib.BZ2_bzReadGetUnused (bzerr, bzf, unusedTmpV, nUnused );
             if (bzerr[0] != BZ_OK) panic ( "test:bzReadGetUnused" );

             unusedTmp = unusedTmpV;
             for (i = 0; i < nUnused[0]; i++) unused[i] = unusedTmp[0].get(i);

             BZLib.BZ2_bzReadClose (bzerr, bzf );
             if (bzerr[0] != BZ_OK) panic ( "test:bzReadGetUnused" );
             if (nUnused[0] == 0) break;// && myfeof(zStream)) break;
          }

        try{
           zStream.close();
       } catch(IOException io){ 
          //break errhandler_io; 
          ioError();
          panic ( "test:end" );
          return true;
       }
       //if (ferror(zStream)) goto errhandler_io;
       //ret = fclose ( zStream );
       //if (ret == EOF) goto errhandler_io;

       //if (verbosity >= 2) fprintf ( stderr, "\n    " );
       if(verbosity >= 2) System.err.print("\n   ");
       return true;
    }
       //errhandler:
       BZLib.BZ2_bzReadClose (bzerr_dummy, bzf );
       if (verbosity == 0) 
          System.err.print(progName + ": " + inName + ": ");
          //fprintf ( stderr, "%s: %s: ", progName, inName );
       switch (bzerr[0]) {
           case BZ_CONFIG_ERROR:
               configError(); break;
           case BZ_IO_ERROR:
	       //errhandler_io:
               ioError(); break;
           case BZ_DATA_ERROR:
	      //fprintf ( stderr,
              //         "data integrity (CRC) error in data\n" );
	      System.err.println("data integrity (CRC) error in data");
              return false;
           case BZ_MEM_ERROR:
               outOfMemory();
           case BZ_UNEXPECTED_EOF:
	      //fprintf ( stderr,
	      //       "file ends unexpectedly\n" );
	      System.err.println("file ends unexpectedly");
              return false;
           case BZ_DATA_ERROR_MAGIC:
	      //if (zStream != stdin) fclose(zStream);
	      if(zStream != stdin) zStream.close();
              //if (streamNo == 1) {
              //fprintf ( stderr, 
	      //        "bad magic number (file not created by bzip2)\n" );
	      //return False;
	      //} else {
	      //if (noisy)
	      //fprintf ( stderr, 
	      //          "trailing garbage after EOF ignored\n" );
	      //return True;       
	      //}
              return false;
          default:
              panic ( "test:unexpected error" );
       }

       panic ( "test:end" );
       return true;
       //return True; /*notreached*/
    }

    /*---------------------------------------------*/
    void compress (String name ) throws IOException
    {
        ReadableByteChannel inStr = null;
        WritableByteChannel outStr = null;
        int n, i;
        //struct MY_STAT statBuf;

        deleteOutputOnInterrupt = false;

        if (name == null && srcMode != SM_I2O)
            panic ( "compress: bad modes\n" );

        switch (srcMode) {
            case SM_I2O: 
	       //copyFileName ( inName, (Char*)"(stdin)" );
	       //copyFileName ( outName, (Char*)"(stdout)" ); 
	       inName = new StringBuilder("(stdin)");
               outName = new StringBuilder("(stdout)");
               break;
            case SM_F2F: 
	        //copyFileName ( inName, name );
	        //copyFileName ( outName, name );
	        inName = new StringBuilder(name);
                outName = new StringBuilder(name);
	        //strcat ( outName, ".bz2" ); 
                outName.append(".bz2");
                break;
            case SM_F2O: 
	        //copyFileName ( inName, name );
	       inName = new StringBuilder(name);
	        //copyFileName ( outName, (Char*)"(stdout)" ); 
               outName = new StringBuilder("(stdout)");
               break;
        }

       if ( srcMode != SM_I2O && containsDubiousChars ( inName ) ) {
          if (noisy)
	      //fprintf ( stderr, "%s: There are no files matching `%s'.\n",
	      //    progName, inName );
             System.err.println(progName + ": There are no files matching '" + inName + "'");
          setExit(1);
          return;
      }
      if ( srcMode != SM_I2O && !(new File(inName.toString()).exists())){//!fileExists ( inName ) ) {
           //fprintf ( stderr, "%s: Can't open input file %s: %s.\n",
           //       progName, inName, strerror(errno) );
           System.err.println(progName + ": Can't open input file " + inName);
           setExit(1);
           return;
      }
      for (i = 0; i < BZ_N_SUFFIX_PAIRS; i++) {
          if (hasSuffix(inName.toString(), zSuffix[i])) {
             if (noisy)
	         //fprintf ( stderr, 
	         //    "%s: Input file %s already has %s suffix.\n",
	         //    progName, inName, zSuffix[i] );
	         System.err.println(progName + ": Input file " + inName + " already has " + zSuffix[i] + " suffix.");
             setExit(1);
             return;
         }
      }
      if ( srcMode == SM_F2F || srcMode == SM_F2O ) {
          //MY_STAT(inName, &statBuf);
          //if ( MY_S_ISDIR(statBuf.st_mode) ) {
          if(new File(inName.toString()).isDirectory()){
	       //fprintf( stderr,
	       //     "%s: Input file %s is a directory.\n",
	       //     progName,inName);
	       System.err.println(progName + ": Input file " + inName + " is a directory.");
               setExit(1);
               return;
          }
       }
       if ( srcMode == SM_F2F && !forceOverwrite && notAStandardFile ( inName )) {
           if (noisy)
	      //fprintf ( stderr, "%s: Input file %s is not a normal file.\n",
	      //    progName, inName );
              System.err.println(progName + "s: Input file " + inName + " is not a normal file.");
          setExit(1);
          return;
       }
       if ( srcMode == SM_F2F && new File(outName.toString()).exists()){//fileExists ( outName ) ) {
          if (forceOverwrite) {
	     remove(outName);
          } else {
	      //fprintf ( stderr, "%s: Output file %s already exists.\n",
	      //   progName, outName );
	      System.err.println(progName + ": Output file " + outName + " already exists.");
	      setExit(1);
	     return;
          }
       }
       //if ( srcMode == SM_F2F && !forceOverwrite &&
        //(n=countHardLinks ( inName )) > 0) {
       //fprintf ( stderr, "%s: Input file %s has %d other link%s.\n",
       //        progName, inName, n, n > 1 ? "s" : "" );
      //  System.err.println(progName + ": Input file " + inName + " has " + n + " other link"+
      //		  (n > 1 ? "s" : "") + ".");
      // setExit(1);
      // return;
      // }

      //if ( srcMode == SM_F2F ) {
         /* Save the file's meta-info before we open it.  Doing it later
            means we mess up the access times. */
          //saveInputFileMetaInfo ( inName );
       //}

      switch ( srcMode ) {

          case SM_I2O:
             inStr = stdin;
             outStr = stdout;
             //if ( isatty ( fileno ( stdout ) ) ) {
	     // fprintf ( stderr,
	     //           "%s: I won't write compressed data to a terminal.\n",
	     //           progName );
	     // fprintf ( stderr, "%s: For help, type: `%s --help'.\n",
	     //                   progName, progName );
	     // setExit(1);
	     // return;
             //};
             break;

          case SM_F2O:
	      inStr = new FileInputStream(inName.toString()).getChannel();//fopen ( inName, "rb" );
              outStr = stdout;
              //if ( isatty ( fileno ( stdout ) ) ) {
	      // fprintf ( stderr,
	      //"%s: I won't write compressed data to a terminal.\n",
			  //           progName );
	     //  fprintf ( stderr, "%s: For help, type: `%s --help'.\n",
	     //                    progName, progName );
             // if ( inStr != NULL ) fclose ( inStr );
             //       setExit(1);
            //       return;
            //    };
            if ( inStr == null ) {
	        System.err.println(progName + ": Can't open input file " + inName );//%s.\n",
	          //progName, inName, strerror(errno) );
                setExit(1);
                return;
             };
             break;

          case SM_F2F:
	      inStr = new FileInputStream(inName.toString()).getChannel();//fopen ( inName, "rb" );
              outStr = fopen_output_safely ( outName, "wb" );
              if ( outStr == null) {
	         System.err.println(progName + ": Can't create output file " + outName); //%s: %s.\n",
	         //progName, outName, strerror(errno) );
                 //if ( inStr != NULL ) fclose ( inStr );
                 if(inStr != null) inStr.close();
                 setExit(1);
                 return;
              }
              if ( inStr == null ) {
	          System.err.println(progName + ": Can't open input file " + inName);//: %s.\n",
	          //progName, inName, strerror(errno) );
                  if ( outStr != null ) outStr.close();
                  setExit(1);
                  return;
              };
              break;
          default:
              panic ( "compress: bad srcMode" );
              break;
       }

       if (verbosity >= 1) {
           //fprintf ( stderr,  "  %s: ", inName );
           System.err.print("  " + inName);
           pad ( inName );
           //fflush ( stderr );
           System.err.flush();
       }

       /*--- Now the input and output handles are sane.  Do the Biz. ---*/
       outputHandleJustInCase = outStr;
       deleteOutputOnInterrupt = true;
       compressStream ( inStr, outStr );
       outputHandleJustInCase = null;

       /*--- If there was an I/O error, we won't get here. ---*/
       if ( srcMode == SM_F2F ) {
          applySavedTimeInfoToOutputFile ( outName );
          deleteOutputOnInterrupt = false;
          if ( !keepInputFiles ) {
             int retVal = remove ( inName );
             ERROR_IF_NOT_ZERO ( retVal );
          }
       }

       deleteOutputOnInterrupt = false;
    }


    static String[] zSuffix = { ".bz2", ".bz", ".tbz2", ".tbz" };
    static String[] unzSuffix = { "", "", ".tar", ".tar" };

    static boolean hasSuffix (String s, String suffix ){
        int ns = s.length();
        int nx = suffix.length();
        if (ns < nx) return false;
        //if (strcmp(s + ns - nx, suffix) == 0) return True;
        if(s.endsWith(suffix)) return true;
        return false;
     }

     static boolean mapSuffix ( StringBuilder name, 
                 String oldSuffix, 
                 String newSuffix ){
         if (!hasSuffix(name.toString(),oldSuffix)) return false;
         //name[strlen(name)-strlen(oldSuffix)] = 0;
         name.setLength(name.length() - oldSuffix.length());
         //strcat ( name, newSuffix );
         name.append(newSuffix);
         return true;
    }

    static int remove(StringBuilder sb){
        boolean success =  new File(sb.toString()).delete();
        if(success) return 0;
        return 1;
    }

    static boolean notAStandardFile (CharSequence name )
    {
        return !(new File(name.toString()).isFile());
    }

    static WritableByteChannel fopen_output_safely (CharSequence name, String mode ) throws IOException
    {
        return new RandomAccessFile(name.toString(), "rw").getChannel();
    }

    static void applySavedTimeInfoToOutputFile ( CharSequence dstName )
    {
        //#  if BZ_UNIX
        //IntNative      retVal;
        //struct utimbuf uTimBuf;

        //uTimBuf.actime = fileMetaInfo.st_atime;
        //uTimBuf.modtime = fileMetaInfo.st_mtime;

        //retVal = utime ( dstName, &uTimBuf );
        //ERROR_IF_NOT_ZERO ( retVal );
        //#  endif
    }

    //void ERROR_IF_EOF(int i)       { if ((i) == EOF)  ioError(); }
    void ERROR_IF_NOT_ZERO(int i)  { if ((i) != 0)    ioError(); }
    void ERROR_IF_MINUS_ONE(int i) { if ((i) == (-1)) ioError(); }

    void uncompress (String name ) throws IOException
   {
       ReadableByteChannel inStr = null;
       WritableByteChannel outStr = null;
       int n, i;
       boolean  magicNumberOK;
       boolean  cantGuess;
       //struct MY_STAT statBuf;

       deleteOutputOnInterrupt = false;

       if (name == null && srcMode != SM_I2O)
          panic ( "uncompress: bad modes\n" );

       cantGuess = false;
       zzz:
       switch (srcMode) {
          case SM_I2O: 
	      //copyFileName ( inName, (Char*)"(stdin)" );
	      inName = new StringBuilder("(stdin)");
	      //copyFileName ( outName, (Char*)"(stdout)" ); 
              outName = new StringBuilder("(stdout)");
             break;
         case SM_F2F: 
	     //copyFileName ( inName, name );
	     inName = new StringBuilder(name);
	     //copyFileName ( outName, name );
             outName = new StringBuilder(name);
             for (i = 0; i < BZ_N_SUFFIX_PAIRS; i++)
                 if (mapSuffix(outName,zSuffix[i],unzSuffix[i]))
                     break zzz; 
             cantGuess = true;
             //strcat ( outName, ".out" );
             outName.append(".out");
             break;
         case SM_F2O: 
	     //copyFileName ( inName, name );
	     inName = new StringBuilder(name);
	     //copyFileName ( outName, (Char*)"(stdout)" ); 
             outName = new StringBuilder("(stdout)");
            break;
       }

       zzz:
       if ( srcMode != SM_I2O && containsDubiousChars ( inName ) ) {
          if (noisy)
	      //fprintf ( stderr, "%s: There are no files matching `%s'.\n",
	      //    progName, inName );
              System.err.println(progName + ": There are no files matching `" + inName + "'");
          setExit(1);
          return;
       }
       if ( srcMode != SM_I2O && !(new File(inName.toString()).exists())){//!fileExists ( inName ) ) {
           //fprintf ( stderr, "%s: Can't open input file %s: %s.\n",
           //       progName, inName, strerror(errno) );
           System.err.println(progName + ": Can't open input file " + inName);
          setExit(1);
          return;
       }
       if ( srcMode == SM_F2F || srcMode == SM_F2O ) {
           //MY_STAT(inName, &statBuf);
           //if ( MY_S_ISDIR(statBuf.st_mode) ) {
           if(new File(inName.toString()).isDirectory()){
	       //fprintf( stderr,
	       //     "%s: Input file %s is a directory.\n",
	      //     progName,inName);
	       System.err.println(progName + ": Input file %s is a directory.");
              setExit(1);
              return;
          }
       }
       if ( srcMode == SM_F2F && !forceOverwrite && notAStandardFile ( inName )) {
          if (noisy)
	      //fprintf ( stderr, "%s: Input file %s is not a normal file.\n",
	      //    progName, inName );
              System.err.println(progName + ": Input file " + inName + " is not a normal file.");
          setExit(1);
          return;
       }
       if ( /* srcMode == SM_F2F implied && */ cantGuess ) {
          if (noisy)
	      //fprintf ( stderr, 
	      //    "%s: Can't guess original name for %s -- using %s\n",
	      //    progName, inName, outName );
              System.err.println(progName + ": Can't guess original name for " + inName + " -- using " + outName);
          /* just a warning, no return */
       }   
       if ( srcMode == SM_F2F && new File(outName.toString()).exists()){//fileExists ( outName ) ) {
          if (forceOverwrite) {
	    remove(outName);
          } else {
	      //fprintf ( stderr, "%s: Output file %s already exists.\n",
              //      progName, outName );
              System.err.println(progName + ": Output file " + outName + " already exists.");
            setExit(1);
            return;
         }
      }
      //if ( srcMode == SM_F2F && !forceOverwrite &&
      //   (n=countHardLinks ( inName ) ) > 0) {
       //fprintf ( stderr, "%s: Input file %s has %d other link%s.\n",
       //       progName, inName, n, n > 1 ? "s" : "" );
      // setExit(1);
      /// return;
      //}/

      //if ( srcMode == SM_F2F ) {
           /* Save the file's meta-info before we open it.  Doing it later
          means we mess up the access times. */
          //saveInputFileMetaInfo ( inName );
          //}

      switch ( srcMode ) {

          case SM_I2O:
              inStr = stdin;
              outStr = stdout;
              //if ( isatty ( fileno ( stdin ) ) ) {
	      // fprintf ( stderr,
	      //           "%s: I won't read compressed data from a terminal.\n",
	      //           progName );
	      // fprintf ( stderr, "%s: For help, type: `%s --help'.\n",
	      //                   progName, progName );
	      // setExit(1);
	      // return;
              //};
              break;
          case SM_F2O:
	      try{
	          inStr = new FileInputStream(inName.toString()).getChannel();//fopen ( inName, "rb" );
	      } catch(IOException x){}
              outStr = stdout;
             if ( inStr == null ) {
	        //fprintf ( stderr, "%s: Can't open input file %s:%s.\n",
	        //       progName, inName, strerror(errno) );
	        System.err.println(progName + ": Can't open input file " + inName);
                if ( inStr != null ) inStr.close();//fclose ( inStr );
                setExit(1);
                return;
             };
             break;
          case SM_F2F:
	      try{
	          inStr = new FileInputStream(inName.toString()).getChannel();//fopen ( inName, "rb" );
	      } catch(IOException x){}
              outStr = fopen_output_safely ( outName, "wb" );
              if ( outStr == null) {
	         //fprintf ( stderr, "%s: Can't create output file %s: %s.\n",
	         //       progName, outName, strerror(errno) );
	         System.err.println(progName + ": Can't create output file " + outName);
	         if ( inStr != null ) inStr.close();// fclose ( inStr );
                 setExit(1);
                 return;
             }
             if ( inStr == null ) {
	         //fprintf ( stderr, "%s: Can't open input file %s: %s.\n",
	         //       progName, inName, strerror(errno) );
	         System.err.println(progName + ": Can't open input file " + inName);
                 if ( outStr != null ) outStr.close();// fclose ( outStr );
                 setExit(1);
                 return;
             };
             break;
          default:
             panic ( "uncompress: bad srcMode" );
             break;
       }

       if (verbosity >= 1) {
           //fprintf ( stderr, "  %s: ", inName );
           System.err.print("  " + inName + ": " );
           pad ( inName );
           //fflush ( stderr );
           System.err.flush();
       }

       /*--- Now the input and output handles are sane.  Do the Biz. ---*/
       outputHandleJustInCase = outStr;
       deleteOutputOnInterrupt = true;
       magicNumberOK = uncompressStream ( inStr, outStr);
       outputHandleJustInCase = null;

       /*--- If there was an I/O error, we won't get here. ---*/
       if ( magicNumberOK ) {
          if ( srcMode == SM_F2F ) {
             applySavedTimeInfoToOutputFile ( outName );
             deleteOutputOnInterrupt = false;
             if ( !keepInputFiles ) {
                int retVal = remove ( inName );
                ERROR_IF_NOT_ZERO ( retVal );
             }
          }
       } else {
          unzFailsExist = true;
          deleteOutputOnInterrupt = false;
          if ( srcMode == SM_F2F ) {
             int retVal = remove ( outName );
             ERROR_IF_NOT_ZERO ( retVal );
          }
       }
       deleteOutputOnInterrupt = false;

       if ( magicNumberOK ) {
          if (verbosity >= 1)
	      //fprintf ( stderr, "done\n" );
              System.err.println("done");
          } else {
              setExit(2);
              if (verbosity >= 1)
	          //fprintf ( stderr, "not a bzip2 file.\n" ); else
	          System.err.println("not a bzip2 file."); 
              else
                  System.err.println(progName + ": " + inName + " is not a bzip2 file.");
	      //fprintf ( stderr,
	      //       "%s: %s is not a bzip2 file.\n",
	      //       progName, inName );
          }
    }
}