package org.jythonx.bzip2;

public class decompress implements BZConstants{


    private static final boolean dumpThreadOnError = false;

    public static void makeMaps_d (DState s){
        int i;
        s.nInUse = 0;
        for (i = 0; i < 256; i++){
            if (s.inUse[i]) {
                s.seqToUnseq[s.nInUse] = (byte)i;
                s.nInUse++;
            }
	}
    }

    public static void SET_LL(byte[] ll4, ShortView ll16, int i, int n){
	ll16.put(i, (short)(n & 0x0000ffff));
        n >>= 16;
        if((i & 0x1) == 0){
            ll4[(i) >> 1] = (byte)((ll4[(i) >> 1] & 0xf0) | (n));
	} else{
	    ll4[(i) >> 1] = (byte)((ll4[(i) >> 1] & 0x0f) | ((n) << 4));
	}
    }

    static void stream_op(DState s){
        bz_stream strm = s.strm;
        s.bsBuff = (((s.bsBuff << 8) & UINT32) | (strm.get_next_in() & 0xff));
        //((UInt32)                              
        // (*((UChar*)(s.strm.next_in))));   
        s.bsLive += 8;                             
        //s.strm.next_in++; 
        strm.inc_next_in();
        strm.avail_in--;                        
        strm.total_in_lo32++;                   
        if (strm.total_in_lo32 == 0)            
            strm.total_in_hi32++; 
    }

    static int chrs = 0;


    /**---------------------------------------------------*/
    public static int BZ2_decompress (final DState s){
        byte      uc = -1;
        int      retVal;
        int      minLen, maxLen;
        bz_stream strm = s.strm;

        /** stuff that needs to be saved/restored */
        int  i;
        int  j;
        int  t;
        int  alphaSize;
        int  nGroups;
        int  nSelectors;
        int  EOB;
        int  groupNo;
        int  groupPos;
        int  nextSym;
        int  nblockMAX;
        int  nblock;
        int  es;
        int  N;
        int  curr;
        int  zt;
        int  zn; 
        int  zvec;
        int  zj;
        int  gSel;
        int  gMinlen;
        int[] gLimit;
        int[] gBase;
        int[] gPerm;

        if (s.state == BZ_X_MAGIC_1) {
	    /**initialise the save area*/
           s.save_i           = 0;
           s.save_j           = 0;
           s.save_t           = 0;
           s.save_alphaSize   = 0;
           s.save_nGroups     = 0;
           s.save_nSelectors  = 0;
           s.save_EOB         = 0;
           s.save_groupNo     = 0;
           s.save_groupPos    = 0;
           s.save_nextSym     = 0;
           s.save_nblockMAX   = 0;
           s.save_nblock      = 0;
           s.save_es          = 0;
           s.save_N           = 0;
           s.save_curr        = 0;
           s.save_zt          = 0;
           s.save_zn          = 0;
           s.save_zvec        = 0;
           s.save_zj          = 0;
           s.save_gSel        = 0;
           s.save_gMinlen     = 0;
           s.save_gLimit      = null;
           s.save_gBase       = null;
           s.save_gPerm       = null;
	}

	/**restore from the save area*/
        i           = s.save_i;
        j           = s.save_j;
        t           = s.save_t;
        alphaSize   = s.save_alphaSize;
        nGroups     = s.save_nGroups;
        nSelectors  = s.save_nSelectors;
        EOB         = s.save_EOB;
        groupNo     = s.save_groupNo;
        groupPos    = s.save_groupPos;
        nextSym     = s.save_nextSym;
        nblockMAX   = s.save_nblockMAX;
        nblock      = s.save_nblock;
        es          = s.save_es;
        N           = s.save_N;
        curr        = s.save_curr;
        zt          = s.save_zt;
        zn          = s.save_zn; 
        zvec        = s.save_zvec;
        zj          = s.save_zj;
        gSel        = s.save_gSel;
        gMinlen     = s.save_gMinlen;
        gLimit      = s.save_gLimit;
        gBase       = s.save_gBase;
        gPerm       = s.save_gPerm;

        long v;
        final int _1lshft8m1 = ((1 << 8) -1);
        final int _1lshft1m1 = ((1 << 1) -1);
        int s_state = s.state;

        retVal = BZ_OK;
        
	save_state_and_return:{
	endhdr_2:{
        switch (s.state) {
	   //GET_UCHAR(BZ_X_MAGIC_1, uc);
	   // GETUCHAR
          case BZ_X_MAGIC_1:
	      s_state = s.state = BZ_X_MAGIC_1;
              while (true) {                                 
                  if (s.bsLive >= 8) {                     
	              //long v; //UINT32                                
                      v = (s.bsBuff >>                        
			   (s.bsLive-8)) & _1lshft8m1;//((1 << 8)-1);   
                      s.bsLive -= 8;                        
                      uc = (byte)v;
                      break;                                   
                  }                                           
                  if (s.strm.avail_in == 0){
                     retVal = BZ_OK; break save_state_and_return;
                  }
                  stream_op(s);
              }
              if ((uc & 0xff) != BZ_HDR_B){
                  //RETURN(BZ_DATA_ERROR_MAGIC);
                  if(dumpThreadOnError)
                      Thread.dumpStack();
                  retVal = BZ_DATA_ERROR_MAGIC; break save_state_and_return;
              }
	      //GET_UCHAR(BZ_X_MAGIC_2, uc);
          case BZ_X_MAGIC_2:
	      s_state = s.state = BZ_X_MAGIC_2;
              while (true) {                                 
                  if (s.bsLive >= 8) {                     
		      //long v; //UINT32                                
                     v = (s.bsBuff >>                        
			  (s.bsLive-8)) & _1lshft8m1;//((1 << 8)-1);   
                     s.bsLive -= 8;                        
                     uc = (byte)v;
                     break;                                   
                  }                                           
                  if (s.strm.avail_in == 0){
                     retVal = BZ_OK; break save_state_and_return;
                  }
                  stream_op(s);
              }
	      if ((uc & 0xff) != BZ_HDR_Z){
		 //RETURN(BZ_DATA_ERROR_MAGIC)
                  if(dumpThreadOnError)
                      Thread.dumpStack();
                 retVal = BZ_DATA_ERROR_MAGIC; break save_state_and_return;
              }
          //GET_UCHAR(BZ_X_MAGIC_3, uc)
         case BZ_X_MAGIC_3:
	     s_state = s.state = BZ_X_MAGIC_3;
             while (true) {                                 
                 if (s.bsLive >= 8) {                     
	             //long v; //UINT32                                
                     v = (s.bsBuff >>                        
			  (s.bsLive-8)) & _1lshft8m1;//((1 << 8)-1);   
                     s.bsLive -= 8;                        
                     uc = (byte)v;                                 
                     break;                                   
                 }                                           
                 if (s.strm.avail_in == 0){
                     retVal = BZ_OK; break save_state_and_return;
                 }
                 stream_op(s);
             }
	     if ((uc & 0xff) != BZ_HDR_h){
                 //RETURN(BZ_DATA_ERROR_MAGIC);
                 if(dumpThreadOnError)
                     Thread.dumpStack();
                 retVal = BZ_DATA_ERROR_MAGIC; break save_state_and_return;
             }

         //GET_BITS(BZ_X_MAGIC_4, s.blockSize100k, 8)
         //GET_BITS(DState s, int lll, int vvv, int nnn){
         case BZ_X_MAGIC_4: 
             s_state = s.state = BZ_X_MAGIC_4;                      
             while (true) {                                 
                 if (s.bsLive >= 8) {                     
	             //long v; //UINT32                                
                     v = (s.bsBuff >>                        
			  (s.bsLive-8)) & _1lshft8m1;//((1 << 8)-1);   
                     s.bsLive -= 8;                        
                     s.blockSize100k = (int)v;                                 
                     break;                                   
                 }                                           
                 if (s.strm.avail_in == 0){
                     retVal = BZ_OK; break save_state_and_return;
                     //RETURN(BZ_OK);
                 }
                 stream_op(s);
             } 
             if (s.blockSize100k < (BZ_HDR_0 + 1) || 
	         s.blockSize100k > (BZ_HDR_0 + 9)){
	         //RETURN(BZ_DATA_ERROR_MAGIC);
                 if(dumpThreadOnError)
                     Thread.dumpStack();
                 retVal = BZ_DATA_ERROR_MAGIC; break save_state_and_return;
             }
             s.blockSize100k -= BZ_HDR_0;

             if (s.smallDecompress) {
                  //s.ll16 = BZALLOC( s->blockSize100k * 100000 * sizeof(UInt16) );
                  s.ll16 = new ShortView(new byte[s.blockSize100k * 100000 * 2]);
                  //s.ll4  = BZALLOC( 
	          //      ((1 + s->blockSize100k * 100000) >> 1) * sizeof(UChar) 
	          //   );
                  s.ll4 = new byte[((1 + s.blockSize100k * 100000) >> 1) * 8];
	          //if (s.ll16 == null || s.ll4 == null){
                      //RETURN(BZ_MEM_ERROR);
		  //  retVal = BZ_MEM_ERROR; break save_state_and_return;
                  //}
              } else {
                  //s.tt  = BZALLOC( s->blockSize100k * 100000 * sizeof(Int32) );
                  s.tt = new IntView(new byte[s.blockSize100k* 100000 * 4]);
                  //if (s.tt == null){
                      //RETURN(BZ_MEM_ERROR);
		  //  retVal = BZ_MEM_ERROR; break save_state_and_return;
                  //}
              }

          //GET_UCHAR(BZ_X_BLKHDR_1, uc);
          case BZ_X_BLKHDR_1: 
	      s_state = s.state = BZ_X_BLKHDR_1;
              while (true) {                                 
                  if (s.bsLive >= 8) {                     
	              //long v; //UINT32                                
                      v = (s.bsBuff >>                        
			   (s.bsLive-8)) & _1lshft8m1;//((1 << 8)-1);   
                      s.bsLive -= 8;                        
                      uc = (byte)v;                                 
                      break;                                   
                  }                                           
                  if (s.strm.avail_in == 0){
                     retVal = BZ_OK; break save_state_and_return;
                  }
                  stream_op(s);
              }
              if ((uc & 0xff) == 0x17){
                  break endhdr_2;
              }//end of endhdr_2
              if ((uc & 0xff) != 0x31){
                  ///RETURN(BZ_DATA_ERROR);
		     //RETURN(BZ_DATA_ERROR);
                  if(dumpThreadOnError)
                      Thread.dumpStack();
                  retVal = BZ_DATA_ERROR; break save_state_and_return;
	      }
          //GET_UCHAR(BZ_X_BLKHDR_2, uc);
          case BZ_X_BLKHDR_2:
	      s_state = s.state = BZ_X_BLKHDR_2;
              while (true) {                                 
                  if (s.bsLive >= 8) {                     
	              //long v; //UINT32                                
                      v = (s.bsBuff >>                        
			   (s.bsLive-8)) & _1lshft8m1;//((1 << 8)-1);   
                      s.bsLive -= 8;                        
                      uc = (byte)v;                                 
                      break;                                   
                  }                                           
                  if (s.strm.avail_in == 0){
                     retVal = BZ_OK; break save_state_and_return;
                  }
                  stream_op(s);
              }
	      if ((uc & 0xff) != 0x41){
		 //RETURN(BZ_DATA_ERROR);
		     //RETURN(BZ_DATA_ERROR);
                  if(dumpThreadOnError)
                      Thread.dumpStack();
                 retVal = BZ_DATA_ERROR; break save_state_and_return;
              }
          //GET_UCHAR(BZ_X_BLKHDR_3, uc);
          case BZ_X_BLKHDR_3:
	      s_state = s.state = BZ_X_BLKHDR_3;
              while (true) {                                 
                  if (s.bsLive >= 8) {                     
	              //long v; //UINT32                                
                      v = (s.bsBuff >>                        
			   (s.bsLive-8)) & _1lshft8m1;//((1 << 8)-1);   
                      s.bsLive -= 8;                        
                      uc = (byte)v;                                 
                      break;                                   
                  }                                           
                  if (s.strm.avail_in == 0){
                     retVal = BZ_OK; break save_state_and_return;
                  }
                  stream_op(s);
              }
	      if ((uc & 0xff) != 0x59){
		 // RETURN(BZ_DATA_ERROR);
		     //RETURN(BZ_DATA_ERROR);
                  if(dumpThreadOnError)
                      Thread.dumpStack();
                 retVal = BZ_DATA_ERROR; break save_state_and_return;
	      }
          //GET_UCHAR(BZ_X_BLKHDR_4, uc);
          case BZ_X_BLKHDR_4:
	      s_state = s.state = BZ_X_BLKHDR_4;
              while (true) {                                 
                  if (s.bsLive >= 8) {                     
	              //long v; //UINT32                                
                      v = (s.bsBuff >>                        
			   (s.bsLive-8)) & _1lshft8m1;//((1 << 8)-1);   
                      s.bsLive -= 8;                        
                      uc = (byte)v;                                 
                      break;                                   
                  }                                           
                  if (s.strm.avail_in == 0){
                     retVal = BZ_OK; break save_state_and_return;
                  }
                  stream_op(s);
              }
	      if ((uc & 0xff) != 0x26){
                 // RETURN(BZ_DATA_ERROR);
		     //RETURN(BZ_DATA_ERROR);
		 if(dumpThreadOnError)
                      Thread.dumpStack();
                 retVal = BZ_DATA_ERROR; break save_state_and_return;
              }
          //GET_UCHAR(BZ_X_BLKHDR_5, uc);
          case BZ_X_BLKHDR_5:
	      s_state = s.state = BZ_X_BLKHDR_5;
              while (true) {                                 
                 if (s.bsLive >= 8) {                     
	             //long v; //UINT32                                
                     v = (s.bsBuff >>                        
			  (s.bsLive-8)) & _1lshft8m1;//((1 << 8)-1);   
                     s.bsLive -= 8;                        
                     uc = (byte)v;                                 
                     break;                                   
                 }                                           
                 if (s.strm.avail_in == 0){
                     retVal = BZ_OK; break save_state_and_return;
                 }
                 stream_op(s);
             }
	      if ((uc & 0xff) != 0x53){
                 //RETURN(BZ_DATA_ERROR);
		     //RETURN(BZ_DATA_ERROR);
		 if(dumpThreadOnError)
                     Thread.dumpStack();
                 retVal = BZ_DATA_ERROR; break save_state_and_return;
	     }
         //GET_UCHAR(BZ_X_BLKHDR_6, uc);
         case BZ_X_BLKHDR_6:
	     s_state = s.state = BZ_X_BLKHDR_6;
             while (true) {                                 
                 if (s.bsLive >= 8) {                     
	             //long v; //UINT32                                
                     v = (s.bsBuff >>                        
			  (s.bsLive-8)) & _1lshft8m1;//((1 << 8)-1);   
                     s.bsLive -= 8;                        
                     uc = (byte)v;                                 
                     break;                                   
                 }                                           
                 if (s.strm.avail_in == 0){
                     retVal = BZ_OK; break save_state_and_return;
                 }
                 stream_op(s);
             }
	     if ((uc & 0xff) != 0x59){
                 //RETURN(BZ_DATA_ERROR);
		     //RETURN(BZ_DATA_ERROR);
                 if(dumpThreadOnError)
                     Thread.dumpStack();
                 retVal = BZ_DATA_ERROR; break save_state_and_return;
	     }

             s.currBlockNo++;
             //if (s->verbosity >= 2)
	     // VPrintf1 ( "\n    [%d: huff+mtf ", s->currBlockNo );
             s.storedBlockCRC = 0;
         case BZ_X_BCRC_1:
             //GET_UCHAR(BZ_X_BCRC_1, uc);
	     s_state = s.state = BZ_X_BCRC_1;
             while (true) {                                 
                 if (s.bsLive >= 8) {                     
	             //long v; //UINT32                                
                     v = (s.bsBuff >>                        
			  (s.bsLive-8)) & _1lshft8m1;//((1 << 8)-1);   
                     s.bsLive -= 8;                        
                     uc = (byte)v;                                 
                     break;                                   
                 }                                           
                 if (s.strm.avail_in == 0){
                     retVal = BZ_OK; break save_state_and_return;
                 }
                 stream_op(s);
             }
             s.storedBlockCRC = ((s.storedBlockCRC << 8) | (uc & 0xff)) & UINT32;// ((UInt32)uc);
             //GET_UCHAR(BZ_X_BCRC_2, uc);
         case BZ_X_BCRC_2:
	     s_state = s.state = BZ_X_BCRC_2;
             while (true) {                                 
                 if (s.bsLive >= 8) {                     
	             //long v; //UINT32                                
                     v = (s.bsBuff >>                        
			  (s.bsLive-8)) & _1lshft8m1;//((1 << 8)-1);   
                     s.bsLive -= 8;                        
                     uc = (byte)v;                                 
                     break;                                   
                 }                                           
                 if (s.strm.avail_in == 0){
                    retVal = BZ_OK; break save_state_and_return;
                 }
                 stream_op(s);
             }
             s.storedBlockCRC = ((s.storedBlockCRC << 8) | (uc & 0xff)) & UINT32;//((UInt32)uc);
         //GET_UCHAR(BZ_X_BCRC_3, uc);
         case BZ_X_BCRC_3:
	     s_state = s.state = BZ_X_BCRC_3;
             while (true) {                                 
                 if (s.bsLive >= 8) {                     
	             //long v; //UINT32                                
                     v = (s.bsBuff >>                        
			  (s.bsLive-8)) & _1lshft8m1;//((1 << 8)-1);   
                     s.bsLive -= 8;                        
                     uc = (byte)v;                                 
                     break;                                   
                 }                                           
                 if (s.strm.avail_in == 0){
                     retVal = BZ_OK; break save_state_and_return;
                 }
                 stream_op(s);
             }
             s.storedBlockCRC = ((s.storedBlockCRC << 8) | (uc & 0xff)) & UINT32;//((UInt32)uc);
         //GET_UCHAR(BZ_X_BCRC_4, uc);
         case BZ_X_BCRC_4:
	     s_state = s.state = BZ_X_BCRC_4;
             while (true) {                                 
                 if (s.bsLive >= 8) {                     
	             //long v; //UINT32                                
                     v = (s.bsBuff >>                        
			  (s.bsLive-8)) & _1lshft8m1;//((1 << 8)-1);   
                     s.bsLive -= 8;                        
                     uc = (byte)v;                                 
                     break;                                   
                 }                                           
                 if (s.strm.avail_in == 0){
                     retVal = BZ_OK; break save_state_and_return;
                 }
                 stream_op(s);
             }
             s.storedBlockCRC = ((s.storedBlockCRC << 8) | (uc & 0xff)) & UINT32;//((UInt32)uc);
         //GET_BITS(BZ_X_RANDBIT, s.blockRandomised, 1);
         //GET_BITS(DState s, int lll, int vvv, int nnn){
         case BZ_X_RANDBIT: 
             s_state = s.state = BZ_X_RANDBIT;                      
             while (true) {                                 
                 if (s.bsLive >= 1) {                     
		     //long v; //UINT32                                
                    v = (s.bsBuff >>                        
			 (s.bsLive-1)) & _1lshft1m1;//((1 << 1)-1);   
                    s.bsLive -= 1;                        
                    s.blockRandomised = v != 0;                                 
                    break;                                   
                 }                                           
                 if (s.strm.avail_in == 0){
                     retVal = BZ_OK; break save_state_and_return;
                     //RETURN(BZ_OK);
                 }
                 stream_op(s);
             }  
             s.origPtr = 0;
             //GET_UCHAR(BZ_X_ORIGPTR_1, uc);
         case BZ_X_ORIGPTR_1:
	     s_state = s.state = BZ_X_ORIGPTR_1;
             while (true) {                                 
                 if (s.bsLive >= 8) {                     
	             //long v; //UINT32                                
                     v = (s.bsBuff >>                        
			  (s.bsLive-8)) & _1lshft8m1;//((1 << 8)-1);   
                     s.bsLive -= 8;
                     uc = (byte)v;                                
                     break;                                   
                 }                                           
                 if (s.strm.avail_in == 0){
                     retVal = BZ_OK; break save_state_and_return;
                 }
                 stream_op(s);
             }
             s.origPtr = (s.origPtr << 8) | (uc & 0xff);//((Int32)uc);
         //GET_UCHAR(BZ_X_ORIGPTR_2, uc);
         case BZ_X_ORIGPTR_2:
	     s_state = s.state = BZ_X_ORIGPTR_2;
             while (true) {                                 
                 if (s.bsLive >= 8) {                     
	             //long v; //UINT32                                
                     v = (s.bsBuff >>                        
			  (s.bsLive-8)) & _1lshft8m1;//((1 << 8)-1);   
                     s.bsLive -= 8;                        
                     uc = (byte)v;                                 
                     break;                                   
                 }                                           
                 if (s.strm.avail_in == 0){
                     retVal = BZ_OK; break save_state_and_return;
                 }
                 stream_op(s);
             }
             s.origPtr = (s.origPtr << 8) | (uc & 0xff);// ((Int32)uc);
             //GET_UCHAR(BZ_X_ORIGPTR_3, uc);
         case BZ_X_ORIGPTR_3:
	     s_state = s.state = BZ_X_ORIGPTR_3;
             while (true) {                                 
                 if (s.bsLive >= 8) {  
	             //long v; //UINT32                                
                     v = (s.bsBuff >>                        
			  (s.bsLive-8)) & _1lshft8m1;//((1 << 8)-1);   
                     s.bsLive -= 8;                        
                     uc = (byte)v;
                     break;                                   
                 }                                           
                 if (s.strm.avail_in == 0){
                     retVal = BZ_OK; break save_state_and_return;
                 }
                 stream_op(s);
             }
             s.origPtr = (s.origPtr << 8) | (uc & 0xff);//((Int32)uc);
	     if (s.origPtr < 0){
	         //RETURN(BZ_DATA_ERROR);
		     //RETURN(BZ_DATA_ERROR);
		 if(dumpThreadOnError)
                  Thread.dumpStack();
                 retVal = BZ_DATA_ERROR; break save_state_and_return;
             }
	     if (s.origPtr > 10 + 100000*s.blockSize100k) {
	         //RETURN(BZ_DATA_ERROR);
		     //RETURN(BZ_DATA_ERROR);
                 if(dumpThreadOnError)
                     Thread.dumpStack();
                 retVal = BZ_DATA_ERROR; break save_state_and_return;
	     }
	     /**--- Receive the mapping table ---*/
	case BZ_X_MAPPING_1:
	     if(s.state != BZ_X_MAPPING_1) i = 0;
             for (; i < 16; i++) {
                 //GET_BIT(BZ_X_MAPPING_1, uc);
	         //case BZ_X_MAPPING_1: 
	         //if(s.state == BZ_X_MAPPING_1){
                    s_state = s.state = BZ_X_MAPPING_1;                      
                    while (true) {                                 
                        if (s.bsLive >= 1) {                     
	                    //long v; //UINT32                                
                            v = (s.bsBuff >>                        
				 (s.bsLive-1)) & _1lshft1m1;//((1 << 1)-1);   
                            s.bsLive -= 1;                        
                            uc = (byte)v;                                 
                            break;                                   
                        }                                           
                        if (s.strm.avail_in == 0){         
                            retVal = BZ_OK; break save_state_and_return;
                        }   
                        stream_op(s);
                    } 
	            //}
		    if ((uc & 0xff) == 1) 
                    s.inUse16[i] = true; else 
                    s.inUse16[i] = false;
	     }
             for (i = 0; i < 256; i++) s.inUse[i] = false;
	case BZ_X_MAPPING_2:
	    boolean bz_xmapping = s.state != BZ_X_MAPPING_2;
             if(bz_xmapping) i = 0;
             for (; i < 16; i++){
                 if (s.inUse16[i]){
                     if(bz_xmapping){
                         j = 0;
                     } else bz_xmapping = true;
                     for (; j < 16; j++) {
                         //GET_BIT(BZ_X_MAPPING_2, uc);
                         //case BZ_X_MAPPING_2:
		         //if(s.state == BZ_X_MAPPING_2){
                             s_state = s.state = BZ_X_MAPPING_2;                      
                             while (true) {                                 
                                 if (s.bsLive >= 1) {                     
	                             //long v; //UINT32                                
                                     v = (s.bsBuff >>                        
					  (s.bsLive-1)) & _1lshft1m1;//((1 << 1)-1);   
                                     s.bsLive -= 1;                        
                                     uc = (byte)v;                                 
                                     break;                                   
                                 }                                           
                                 if (s.strm.avail_in == 0){         
                                     retVal = BZ_OK; break save_state_and_return;
                                 }   
                                 stream_op(s);
                             } 
			     //}
			     if ((uc & 0xff)== 1) s.inUse[i * 16 + j] = true;
                     } } }
                     makeMaps_d ( s );
                     if (s.nInUse == 0){
                         //RETURN(BZ_DATA_ERROR);
		     //RETURN(BZ_DATA_ERROR);
                         if(dumpThreadOnError)
                             Thread.dumpStack();
                         retVal = BZ_DATA_ERROR; break save_state_and_return;
                     }
                     alphaSize = s.nInUse+2;

                 /**--- Now the selectors ---*/
                 //GET_BITS(BZ_X_SELECTOR_1, nGroups, 3);
	         //GET_BITS(DState s, int lll, int vvv, int nnn){
                 case BZ_X_SELECTOR_1: 
                    s_state = s.state = BZ_X_SELECTOR_1;                      
                    while (true) {                                 
                        if (s.bsLive >= 3) {                     
	                    //long v; //UINT32                                
                            v = (s.bsBuff >>                        
                                (s.bsLive-3)) & ((1 << 3)-1);   
                            s.bsLive -= 3;                        
                            nGroups = (int)v;                                 
                            break;                                   
                        }                                           
                        if (s.strm.avail_in == 0){
                            retVal = BZ_OK; break save_state_and_return;
                            //RETURN(BZ_OK);
                        }
                        stream_op(s);
                    } 
                    if (nGroups < 2 || nGroups > 6){
                        //RETURN(BZ_DATA_ERROR);
		     //RETURN(BZ_DATA_ERROR);
                        if(dumpThreadOnError)
                            Thread.dumpStack();
                        retVal = BZ_DATA_ERROR; break save_state_and_return;
                    }
                //GET_BITS(BZ_X_SELECTOR_2, nSelectors, 15);
                //GET_BITS(DState s, int lll, int vvv, int nnn){
                case BZ_X_SELECTOR_2: 
                    s_state = s.state = BZ_X_SELECTOR_2;                      
                    while (true) {                                 
                        if (s.bsLive >= 15) {                     
	                    //long v; //UINT32                                
                            v = (s.bsBuff >>                        
                                (s.bsLive-15)) & ((1 << 15)-1);   
                            s.bsLive -= 15;                        
                            nSelectors = (int)v;                                 
                            break;                                    
                        }                                           
                        if (s.strm.avail_in == 0){
                            retVal = BZ_OK; break save_state_and_return;
                            //RETURN(BZ_OK);
                        }
                        stream_op(s);
		    }
                if (nSelectors < 1) {
	            //RETURN(BZ_DATA_ERROR);
		    if(dumpThreadOnError)
                        Thread.dumpStack();
                    retVal = BZ_DATA_ERROR; break save_state_and_return;
                }
	        case BZ_X_SELECTOR_3:
                    int selectn = 0;
		    boolean match = s.state == BZ_X_SELECTOR_3;
                    if(!match){
		    for (i =  0; i < nSelectors; i++) {
                        j = 0;
                    while (true) {
                        //GET_BIT(BZ_X_SELECTOR_3, uc);
		        //case BZ_X_SELECTOR_3:
		        //if(s.state == BZ_X_SELECTOR_3){
                        s_state = s.state = BZ_X_SELECTOR_3;
                        while (true) {     
                            if (s.bsLive >= 1) {                     
	                        //long v; //UINT32                                
                                 v = (s.bsBuff >>                        
				      (s.bsLive-1)) & _1lshft1m1;//((1 << 1)-1);   
                                s.bsLive -= 1;                        
                                uc = (byte)v;                                 
                                break;                                   
                             }                                           
                             if (s.strm.avail_in == 0){         
                                 retVal = BZ_OK; break save_state_and_return;
                             }   
                             stream_op(s);
                        } 
				//}
			if ((uc & 0xff)== 0) break;
                            j++;
                            if (j >= nGroups){
                                //RETURN(BZ_DATA_ERROR);
                                if(dumpThreadOnError)
                                    Thread.dumpStack();
                                retVal = BZ_DATA_ERROR; break save_state_and_return;
                            }
		        }
			s.selectorMtf[i] = (byte)j;
                    } }
                    else{
			//for (i =  0; i < nSelectors; i++) {
			do{ 
			    j = match? j: 0;
                            match = false;
                         while (true) {
                        //GET_BIT(BZ_X_SELECTOR_3, uc);
		        //case BZ_X_SELECTOR_3:
		        //if(s.state == BZ_X_SELECTOR_3){
                        s_state = s.state = BZ_X_SELECTOR_3;
                        while (true) {                                 
                            if (s.bsLive >= 1) {                     
	                        //long v; //UINT32                                
                                 v = (s.bsBuff >>                        
				      (s.bsLive-1)) & _1lshft1m1;//((1 << 1)-1);   
                                s.bsLive -= 1;                        
                                uc = (byte)v;                                 
                                break;                                   
                             }                                           
                             if (s.strm.avail_in == 0){         
                                 retVal = BZ_OK; break save_state_and_return;
                             }   
                             stream_op(s);
                        } 
				//}
			if ((uc & 0xff)== 0) break;
                            j++;
                            if (j >= nGroups){
                                //RETURN(BZ_DATA_ERROR);
                                if(dumpThreadOnError)
                                    Thread.dumpStack();
                                retVal = BZ_DATA_ERROR; break save_state_and_return;
                            }
		        }
			s.selectorMtf[i] = (byte)j;
                        i++;
	                } while(i < nSelectors);
		    }

                    /**--- Undo the MTF values for the selectors. ---*/
                    {
                        byte[] pos = new byte[BZ_N_GROUPS]; //UChar
                        int tmp, v2; //UChar
                        for (v2 = 0; v2 < nGroups; v2++) pos[v2] = (byte)v2;
   
                        for (i = 0; i < nSelectors; i++) {
                            v2 = s.selectorMtf[i] & 0xff;
                            tmp = pos[v2];
                            while (v2 > 0) { pos[v2] = pos[v2-1]; v2--; }
                            pos[0] = (byte)tmp;
                            s.selector[i] = (byte)tmp;
                        }
                    }

	case BZ_X_CODING_1:
        case BZ_X_CODING_2:
        case BZ_X_CODING_3:
            //fake uc init:
            uc = 0;
	    int state = s.state;
            /**--- Now the coding tables ---*/
            if(state == BZ_X_CODING_1 || state == BZ_X_CODING_2 || state == BZ_X_CODING_3);
            else state = -1000;
            if(state == -1000) t = 0;
            for (; t < nGroups; t++) {
                  //GET_BITS(BZ_X_CODING_1, curr, 5);
	          //GET_BITS(DState s, int lll, int vvv, int nnn){
	          //case BZ_X_CODING_1: 
                  //if(s.state == BZ_X_CODING_1){
		   if(state == BZ_X_CODING_1 || state == -1000){
                            s_state = s.state = BZ_X_CODING_1;                      
                            while (true) {                                 
                                if (s.bsLive >= 5) {                     
	                            //long v; //UINT32                                
                                    v = (s.bsBuff >>                        
                                        (s.bsLive-5)) & ((1 << 5)-1);   
                                    s.bsLive -= 5;                        
                                    curr = (int)v; 
                                    break;                                   
                                 }                                           
                                 if (s.strm.avail_in == 0){
                                     retVal = BZ_OK; break save_state_and_return;
                                     //RETURN(BZ_OK);
                                 }
                                 stream_op(s);
                            }
			    //}
                            state = -1000;
		        }
		        if(state == -1000) i = 0;
                        for (; i < alphaSize; i++) {
                            while (true) {                     
                                if (state == -1000  && (curr < 1 || curr > 20)){
                                    //RETURN(BZ_DATA_ERROR);
                                    if(dumpThreadOnError)
                                        Thread.dumpStack();
                                    retVal = BZ_DATA_ERROR; break save_state_and_return;
                                }
                                //GET_BIT(BZ_X_CODING_2, uc);
		                //case BZ_X_CODING_2:
                                if(state == BZ_X_CODING_2 || state == -1000){
                                    s_state = s.state = BZ_X_CODING_2;                      
                                    while (true) {                                 
                                        if (s.bsLive >= 1) {                     
	                                    //long v; //UINT32                                
                                            v = (s.bsBuff >>                        
						 (s.bsLive-1)) & _1lshft1m1;//((1 << 1)-1);   
                                            s.bsLive -= 1;                        
                                            uc = (byte)v;                                 
                                            break;                                   
                                        }                                           
                                        if (s.strm.avail_in == 0){         
                                            retVal = BZ_OK; break save_state_and_return;
                                        }   
                                        stream_op(s);
                                    } 
                                    state = -1000;
                                }
				    //}
                                if (state == -1000 && (uc & 0xff) == 0) break;
                                //GET_BIT(BZ_X_CODING_3, uc);
		                //case BZ_X_CODING_3:
		                if(state == -1000 || state == BZ_X_CODING_3){
                                    s_state = s.state = BZ_X_CODING_3;                      
                                    while (true) {                                 
                                        if (s.bsLive >= 1) {                     
	                                    //long v; //UINT32                                
                                            v = (s.bsBuff >>                        
						 (s.bsLive-1)) & _1lshft1m1;//((1 << 1)-1);   
                                            s.bsLive -= 1;                        
                                            uc = (byte)v;                                 
                                            break;                                   
                                        }                                           
                                        if (s.strm.avail_in == 0){         
                                            retVal = BZ_OK; break save_state_and_return;
                                        }   
                                        stream_op(s);
				    } 
                                    state = -1000;
				}
                                if (uc == 0) curr++; else curr--;
                            }
                            s.len[t][i] = (byte)curr;
                        }
	            }
	

                    /**--- Create the Huffman decoding tables ---*/
                    for (t = 0; t < nGroups; t++) {
                        minLen = 32;
                        maxLen = 0;
                        int slen;
                        for (i = 0; i < alphaSize; i++) {
                            slen = s.len[t][i] & 0xff;
                            //if ((s.len[t][i] & 0xff) > maxLen) maxLen = s.len[t][i] & 0xff;
                            //if ((s.len[t][i] & 0xff) < minLen) minLen = s.len[t][i] & 0xff;
                            if(slen > maxLen) maxLen = slen;
                            if(slen < minLen) minLen = slen;
                        }
                        huffman.BZ2_hbCreateDecodeTables ( 
                            s.limit[t], 
                            s.base[t], 
                            s.perm[t], 
                            s.len[t],
                            minLen, maxLen, alphaSize
                        );
                        s.minLens[t] = minLen;
                    }

                    /**--- Now the MTF values ---*/

                    EOB      = s.nInUse+1;
                    nblockMAX = 100000 * s.blockSize100k;
                    groupNo  = -1;
                    groupPos = 0;

                    for (i = 0; i <= 255; i++) s.unzftab[i] = 0;

                    /**-- MTF init --*/
                    {
                        int ii, jj, kk;
                        kk = MTFA_SIZE-1;
                        for (ii = 256 / MTFL_SIZE - 1; ii >= 0; ii--) {
                            for (jj = MTFL_SIZE-1; jj >= 0; jj--) {
                                s.mtfa[kk] = (byte)(ii * MTFL_SIZE + jj);
                                kk--;
                            }
                            s.mtfbase[ii] = kk + 1;
                        }
                    }
	            /**-- end MTF init --*/

                    nblock = 0;
                    //GET_MTF_VAL(BZ_X_MTF_1, BZ_X_MTF_2, nextSym);
                    //public static void GET_MTF_VAL(int label1, int label2, int lval)                                            
                    if (groupPos == 0) {                           
                        groupNo++;                                  
                        if (groupNo >= nSelectors){
	                    //RETURN(BZ_DATA_ERROR);  
                            if(dumpThreadOnError)
                                Thread.dumpStack();
                            retVal = BZ_DATA_ERROR; break save_state_and_return;
                        }                 
                        groupPos = BZ_G_SIZE;                       
                        gSel = s.selector[groupNo] & 0xff;                
                        gMinlen = s.minLens[gSel];                 
                        gLimit = s.limit[gSel];
                        gPerm = s.perm[gSel];
                        gBase = s.base[gSel];
                        //gLimit = &(s->limit[gSel][0]);              
                        //gPerm = &(s->perm[gSel][0]);                
                        //gBase = &(s->base[gSel][0]);                
                    }
                    groupPos--;                                    
                    zn = gMinlen;                                  
                    //GET_BITS(label1, zvec, zn);                    
                    //GET_BITS(DState s, int lll, int vvv, int nnn){
            case BZ_X_MTF_1: 
                    //if(s.state == BZ_X_MTF_1){
                        s_state = s.state = BZ_X_MTF_1;                      
                        while (true) {                                 
                            if (s.bsLive >= zn) {    
	                        //long v; //UINT32                                
                                 v = (s.bsBuff >>                        
                                     (s.bsLive-zn)) & ((1 << zn)-1);   
                                 s.bsLive -= zn;                        
                                 zvec = (int)v;                                 
                                 break;                                   
                            }                                           
                            if (s.strm.avail_in == 0){
                                retVal = BZ_OK; break save_state_and_return;
                                //RETURN(BZ_OK);
                            }
                            stream_op(s);
                        }
			//}
	case BZ_X_MTF_2:
	    boolean firstSkip = s.state == BZ_X_MTF_2;
                    while (true) {
                        if(!firstSkip){
                        if (zn > 20 /** the longest code */){
	                    //RETURN(BZ_DATA_ERROR);
                            if(dumpThreadOnError)
                                Thread.dumpStack();
                            retVal = BZ_DATA_ERROR; break save_state_and_return;
                        }        
                        if (zvec <= gLimit[zn]) break;              
                        zn++;                                       
                        //GET_BIT(label2, zj);                        
                        //case BZ_X_MTF_2: 
                        //if(s.state == BZ_X_MTF_2){
                        }
                        firstSkip = false;
                            s_state = s.state = BZ_X_MTF_2;                      
                            while (true) {                                 
                                if (s.bsLive >= 1) {                     
	                            //long v; //UINT32                                
                                    v = (s.bsBuff >>                        
					 (s.bsLive-1)) & _1lshft1m1;//((1 << 1)-1);   
                                    s.bsLive -= 1;                        
                                    zj = (int)v;                                 
                                    break;                                   
                                }                                           
                                if (s.strm.avail_in == 0){         
                                    retVal = BZ_OK; break save_state_and_return;
                                }   
                                stream_op(s);
                            } 
			    //}
                        zvec = (zvec << 1) | zj;                    
                    };                                             
                    if (zvec - gBase[zn] < 0                       
                            || zvec - gBase[zn] >= BZ_MAX_ALPHA_SIZE){
                        //RETURN(BZ_DATA_ERROR);
                        if(dumpThreadOnError)
                            Thread.dumpStack();
                        retVal = BZ_DATA_ERROR; break save_state_and_return;

                    } 
                    //lval = gPerm[zvec - gBase[zn]];
                   nextSym = gPerm[zvec - gBase[zn]];
	case BZ_X_MTF_3:
        case BZ_X_MTF_4:
        case BZ_X_MTF_5:
        case BZ_X_MTF_6:
	    state = s.state;
            boolean bz_x_mtf;
            if(state == BZ_X_MTF_3 || state == BZ_X_MTF_4 || state == BZ_X_MTF_5 || state == BZ_X_MTF_6)
		bz_x_mtf = true;
            else bz_x_mtf = false;
                   while (true) {
                       
                       if (!bz_x_mtf && nextSym == EOB) break;

                       if ((nextSym == BZ_RUNA || nextSym == BZ_RUNB) || (state == BZ_X_MTF_3 || state == BZ_X_MTF_4) ) {
                           if(!bz_x_mtf){
                               es = -1;
                               N = 1;
                           }
                           do {
                               if(!bz_x_mtf){
                               if (nextSym == BZ_RUNA) es = es + (0+1) * N; else
                               if (nextSym == BZ_RUNB) es = es + (1+1) * N;
                               N = N * 2;
                               //GET_MTF_VAL(BZ_X_MTF_3, BZ_X_MTF_4, nextSym);
                               //public static void GET_MTF_VAL(int label1, int label2, int lval)          
                               if (groupPos == 0) {                           
                                   groupNo++;                                  
                                   if (groupNo >= nSelectors){
	                               //RETURN(BZ_DATA_ERROR);  
                                       if(dumpThreadOnError) Thread.dumpStack();
                                       retVal = BZ_DATA_ERROR; break save_state_and_return;
                                   }                 
                                   groupPos = BZ_G_SIZE;                       
                                   gSel = s.selector[groupNo] & 0xff;  
                                   gMinlen = s.minLens[gSel];                 
                                   gLimit = s.limit[gSel];
                                   gPerm = s.perm[gSel];
                                   gBase = s.base[gSel];
                                   //gLimit = &(s->limit[gSel][0]);              
                                   //gPerm = &(s->perm[gSel][0]);                
                                   //gBase = &(s->base[gSel][0]);                
                               }                                              
                               groupPos--;                                    
                               zn = gMinlen; 
                               }                                 
                               //GET_BITS(label1, zvec, zn);                    
                               //GET_BITS(DState s, int lll, int vvv, int nnn){
                               //case BZ_X_MTF_3: 
                               if(state == BZ_X_MTF_3 || !bz_x_mtf){
                                   s_state = s.state = BZ_X_MTF_3;                      
                                   while (true) {                                 
                                       if (s.bsLive >= zn) {                     
	                                   //long v; //UINT32                                
                                           v = (s.bsBuff >>                        
                                               (s.bsLive-zn)) & ((1 << zn)-1);   
                                           s.bsLive -= zn;                        
                                           zvec = (int)v;
                                           break;                                   
                                       }                                           
                                       if (s.strm.avail_in == 0){
                                           retVal = BZ_OK; break save_state_and_return;
                                          //RETURN(BZ_OK);
                                       }
                                       stream_op(s);
                                   }
                                   bz_x_mtf = false;
                                   state = -1;
			       }
    
                               while (true) { 
                                   if(!bz_x_mtf){
                                   if (zn > 20 /** the longest code */){
	                               //RETURN(BZ_DATA_ERROR);
                                       if(dumpThreadOnError) Thread.dumpStack();
                                       retVal = BZ_DATA_ERROR; break save_state_and_return;
                                   }        
                                   if (zvec <= gLimit[zn]) break;              
                                   zn++;         
                                   }                              
                                   //GET_BIT(label2, zj);                        
                                   //case BZ_X_MTF_4: 
                                   if(state == BZ_X_MTF_4 || !bz_x_mtf){
                                       s_state = s.state = BZ_X_MTF_4;                      
                                       while (true) {                                 
                                           if (s.bsLive >= 1) {                     
	                                       //long v; //UINT32                                
                                               v = (s.bsBuff >>                        
						    (s.bsLive-1)) & _1lshft1m1;//((1 << 1)-1);   
                                               s.bsLive -= 1;
                                               zj = (int)v;                          
                                               break;                                   
                                           }                                           
                                           if (s.strm.avail_in == 0){         
                                               retVal = BZ_OK; break save_state_and_return;
                                           }   
                                           stream_op(s);
                                       } 
                                       bz_x_mtf = false; state = -1;
				   }
                                   zvec = (zvec << 1) | zj;                    
                               }; 
                               if (zvec - gBase[zn] < 0                       
                                  || zvec - gBase[zn] >= BZ_MAX_ALPHA_SIZE){
                                   //RETURN(BZ_DATA_ERROR);
                                   if(dumpThreadOnError) Thread.dumpStack();
                                   retVal = BZ_DATA_ERROR; break save_state_and_return;
                               } 
                               nextSym = gPerm[zvec - gBase[zn]];   
                           }
                           while (nextSym == BZ_RUNA || nextSym == BZ_RUNB);

                           es++;
                           uc = s.seqToUnseq[ s.mtfa[s.mtfbase[0]] & 0xff ];
                           s.unzftab[uc & 0xff] += es;

                           if (s.smallDecompress){
                               while (es > 0) {
		                   if (nblock >= nblockMAX){
		                       // RETURN(BZ_DATA_ERROR);
                                       retVal = BZ_DATA_ERROR; break save_state_and_return;
                                   }
                                   //s.ll16[nblock] = (int)uc;
                                   s.ll16.put(nblock, (short)(uc & 0xff));
                                   nblock++;
                                   es--;
                              }
			   }
                           else{
                               while (es > 0) {
		                   if (nblock >= nblockMAX){
                                       //RETURN(BZ_DATA_ERROR);
                                       if(dumpThreadOnError) Thread.dumpStack();
                                       retVal = BZ_DATA_ERROR; break save_state_and_return;
                                   }
                                   //s.tt[nblock] = (long)uc;
                                   s.tt.put(nblock, uc & 0xff);
                                   nblock++;
                                   es--;
                               };
                           }

                           continue;
		       } else {
                           if(!bz_x_mtf){
	                   if (nblock >= nblockMAX){
		               //RETURN(BZ_DATA_ERROR);
                               if(dumpThreadOnError) Thread.dumpStack();
                               retVal = BZ_DATA_ERROR; break save_state_and_return;
                           }

	                   /**-- uc = MTF ( nextSym-1 ) --*/
                           {
                               int ii, jj, kk, pp, lno, off;
                               long nn; //UInt32
                               nn = (long)(nextSym - 1);

                               if (nn < MTFL_SIZE) {
		                   /** avoid general-case expense */
                                   pp = s.mtfbase[0];
                                   uc = s.mtfa[pp+(int)(nn)];
                                   while (nn > 3) {
                                       int z = pp+(int)(nn);
                                       s.mtfa[(z)  ] = s.mtfa[(z)-1];
                                       s.mtfa[(z)-1] = s.mtfa[(z)-2];
                                       s.mtfa[(z)-2] = s.mtfa[(z)-3];
                                       s.mtfa[(z)-3] = s.mtfa[(z)-4];
                                       nn -= 4;
                                   }
                                   while (nn > 0) { 
                                       s.mtfa[(pp+(int)(nn))] = s.mtfa[(pp+(int)(nn))-1]; nn--; 
                                   };
                                   s.mtfa[pp] = uc;
			       } else { 
		                   /** general case */
                                   lno = (int)(nn) / MTFL_SIZE;
                                   off = (int)(nn) % MTFL_SIZE;
                                   pp = s.mtfbase[lno] + off;
                                   uc = s.mtfa[pp];
                                   while (pp > s.mtfbase[lno]) { 
                                       s.mtfa[pp] = s.mtfa[pp-1]; pp--; 
                                   };
                                   s.mtfbase[lno]++;
                                   while (lno > 0) {
                                       s.mtfbase[lno]--;
                                       s.mtfa[s.mtfbase[lno]] 
                                           = s.mtfa[s.mtfbase[lno-1] + MTFL_SIZE - 1];
                                       lno--;
                                   }
                                   s.mtfbase[0]--;
                                   s.mtfa[s.mtfbase[0]] = uc;
                                   if (s.mtfbase[0] == 0) {
                                       kk = MTFA_SIZE-1;
                                       for (ii = 256 / MTFL_SIZE-1; ii >= 0; ii--) {
                                           for (jj = MTFL_SIZE-1; jj >= 0; jj--) {
                                               s.mtfa[kk] = s.mtfa[s.mtfbase[ii] + jj];
                                               kk--;
                                           }
                                           s.mtfbase[ii] = kk + 1;
                                       }
                                   }
                               }
                           }
                           /**-- end uc = MTF ( nextSym-1 ) --*/

                           s.unzftab[s.seqToUnseq[uc & 0xff] & 0xff]++;
                           if (s.smallDecompress){
		               //s.ll16[nblock] = (int)(s.seqToUnseq[uc]);
                               s.ll16.put(nblock, (short)(s.seqToUnseq[uc & 0xff] & 0xff));
                           } else {//UINT16
		               //s.tt[nblock]   = (long)(s.seqToUnseq[uc]); //UINT32
                               s.tt.put(nblock, s.seqToUnseq[uc & 0xff] & 0xff);
                           }
                           nblock++;

                           //GET_MTF_VAL(BZ_X_MTF_5, BZ_X_MTF_6, nextSym);
                           //public static void GET_MTF_VAL(int label1, int label2, int lval)
                           if (groupPos == 0) {                           
                               groupNo++;                                  
                               if (groupNo >= nSelectors){
	                           //RETURN(BZ_DATA_ERROR);  
                                   retVal = BZ_DATA_ERROR; break save_state_and_return;
                               }                 
                               groupPos = BZ_G_SIZE;                       
                               gSel = s.selector[groupNo] & 0xff; 
                               gMinlen = s.minLens[gSel];                 
                               gLimit = s.limit[gSel];
                               gPerm = s.perm[gSel];
                               gBase = s.base[gSel];
                               //gLimit = &(s->limit[gSel][0]);              
                               //gPerm = &(s->perm[gSel][0]);                
                               //gBase = &(s->base[gSel][0]);                
                           }                                              
                           groupPos--;                                    
                           zn = gMinlen;
		           }              
                           //GET_BITS(label1, zvec, zn);                    
                           //GET_BITS(DState s, int lll, int vvv, int nnn){
                           //case BZ_X_MTF_5: 
                           if(state == BZ_X_MTF_5 || !bz_x_mtf){
                               s_state = s.state = BZ_X_MTF_5;                      
                               while (true) {                                 
                                   if (s.bsLive >= zn) {                     
	                               //long v; //UINT32                                
                                       v = (s.bsBuff >>                        
                                           (s.bsLive-zn)) & ((1 << zn)-1);   
                                       s.bsLive -= zn;                        
                                       zvec = (int)v;                                 
                                       break;                                   
                                   }                                           
                                   if (s.strm.avail_in == 0){
                                       retVal = BZ_OK; break save_state_and_return;
                                       //RETURN(BZ_OK);
                                   }
                                   stream_op(s);
			       }
                               bz_x_mtf = false; state = -1;
			   }
    
                           while (true) {
                               if(!bz_x_mtf){
                               if (zn > 20 /** the longest code */){
	                           //RETURN(BZ_DATA_ERROR);
                                   if(dumpThreadOnError) Thread.dumpStack();
                                   retVal = BZ_DATA_ERROR; break save_state_and_return;
                               }        
                               if (zvec <= gLimit[zn]) break;              
                               zn++;
                               }                              
                               //GET_BIT(label2, zj);                        
                               //case BZ_X_MTF_6: 
                               if(state == BZ_X_MTF_6 || !bz_x_mtf){
                                   s_state = s.state = BZ_X_MTF_6;                      
                                   while (true) {                                 
                                       if (s.bsLive >= 1) {                     
	                                   //long v; //UINT32                                
                                           v = (s.bsBuff >>                        
						(s.bsLive-1)) & _1lshft1m1;//((1 << 1)-1);   
                                           s.bsLive -= 1;                        
                                           zj = (int)v;
                                           break;                                   
                                       }                                           
                                       if (s.strm.avail_in == 0){         
                                           retVal = BZ_OK; break save_state_and_return;
                                       }   
                                       stream_op(s);
                                   }
                                   bz_x_mtf = false; state = -1;
			       }
                               zvec = (zvec << 1) | zj;                    
                           };                                             
                           if (zvec - gBase[zn] < 0                       
                               || zvec - gBase[zn] >= BZ_MAX_ALPHA_SIZE){
                               //RETURN(BZ_DATA_ERROR);
                               if(dumpThreadOnError) Thread.dumpStack();
                               retVal = BZ_DATA_ERROR; break save_state_and_return;
                           } 
                           nextSym = gPerm[zvec - gBase[zn]];   
                           continue;
                       }
                   }

	           /** Now we know what nblock is, we can do a better sanity
                       check on s->origPtr.
                     */
	           if (s.origPtr < 0 || s.origPtr >= nblock){
	               //RETURN(BZ_DATA_ERROR);
                       if(dumpThreadOnError) Thread.dumpStack();
                       retVal = BZ_DATA_ERROR; break save_state_and_return;
                   }

	           /**-- Set up cftab to facilitate generation of T^(-1) --*/
                   s.cftab[0] = 0;
                   for (i = 1; i <= 256; i++) s.cftab[i] = s.unzftab[i-1];
                   for (i = 1; i <= 256; i++) s.cftab[i] += s.cftab[i-1];
                   for (i = 0; i <= 256; i++) {
                       if (s.cftab[i] < 0 || s.cftab[i] > nblock) {
	                   /** s->cftab[i] can legitimately be == nblock */
                           //RETURN(BZ_DATA_ERROR);
                           if(dumpThreadOnError) Thread.dumpStack();
                           retVal = BZ_DATA_ERROR; break save_state_and_return;
                       }
                   }

                   s.state_out_len = 0;
                   s.state_out_ch  = 0;
                   s.calculatedBlockCRC = BZLib.BZ_INITIALISE_CRC();
                   s.state = BZ_X_OUTPUT;
                   //if (s.verbosity >= 2) VPrintf0 ( "rt+rld" );

                   if (s.smallDecompress) {
                       smallDecompress1(s, nblock, uc);
                       i = s._i; j = s._j; uc = s._uc;
                   } else {
	               /**-- compute the T^(-1) vector --*/
                       for (i = 0; i < nblock; i++) {
                           //uc = (byte)(s.tt[i] & 0xff);
                           uc = (byte)(s.tt.getUInt32(i) & 0xff);
                           //s.tt[s.cftab[uc]] |= (i << 8);
                           s.tt.put(s.cftab[uc & 0xff], (int)(s.tt.getUInt32(s.cftab[uc & 0xff]) | (i << 8)));
                           s.cftab[uc & 0xff]++;
                       }

                       s.tPos = s.tt.getUInt32(s.origPtr) >> 8;//s.tt[s.origPtr] >> 8;
                       s.nblock_used = 0;
                       if (s.blockRandomised) {
	                   //BZ_RAND_INIT_MASK;
                           s.rNToGo = 0;                              
                           s.rTPos  = 0;
                           //#define BZ_GET_FAST(cccc)
                           //s->tPos = s->tt[s->tPos];
                           //cccc = (UChar)(s->tPos & 0xff);	
                           //s->tPos >>= 8;
                           //BZ_GET_FAST(s.k0); 
                           s.tPos = s.tt.getUInt32((int)s.tPos);//s.tt[s.tPos];
                           s.k0 = ((byte)(s.tPos & 0xff)) & 0xff;
                           s.tPos >>= 8;
                           s.nblock_used++;
                           //BZ_RAND_UPD_MASK; 
                           if (s.rNToGo == 0) {                       
                               s.rNToGo = BZ2_rNums[s.rTPos];         
                               s.rTPos++;                              
                               if (s.rTPos == 512) s.rTPos = 0;       
                           }                                           
                           s.rNToGo--;
                           //((s->rNToGo == 1) ? 1 : 0)
                           s.k0 ^= ((s.rNToGo == 1) ? 1 : 0);//BZ_RAND_MASK; 
                       } else {
                           //BZ_GET_FAST(s.k0); 
                           s.tPos = s.tt.getUInt32((int)s.tPos);//s.tt[s.tPos];
                           s.k0 = ((byte)(s.tPos & 0xff)) & 0xff;
                           s.tPos >>= 8;
                           s.nblock_used++;
                       }
                   }
                   //RETURN(BZ_OK);
                   retVal = BZ_OK; break save_state_and_return;
	}}
        //endhdr_2:
        switch(s_state){
	case BZ_X_MAGIC_1:
        case BZ_X_MAGIC_2:
        case BZ_X_MAGIC_3:
        case BZ_X_MAGIC_4:
        case BZ_X_BLKHDR_1:
        case BZ_X_BLKHDR_2:
        case BZ_X_BLKHDR_3:
        case BZ_X_BLKHDR_4:
        case BZ_X_BLKHDR_5:
        case BZ_X_BLKHDR_6:
        case BZ_X_BCRC_1:
        case BZ_X_BCRC_2:
        case BZ_X_BCRC_3:
        case BZ_X_BCRC_4:
        case BZ_X_RANDBIT:
        case BZ_X_ORIGPTR_1:
        case BZ_X_ORIGPTR_2:
        case BZ_X_ORIGPTR_3:
        case BZ_X_MAPPING_1:
        case BZ_X_MAPPING_2:
        case BZ_X_SELECTOR_1:
        case BZ_X_SELECTOR_2:
        case BZ_X_SELECTOR_3:
        case BZ_X_CODING_1:
        case BZ_X_CODING_2:
        case BZ_X_CODING_3:
        case BZ_X_MTF_1:
        case BZ_X_MTF_2:
        case BZ_X_MTF_3:
        case BZ_X_MTF_4:
        case BZ_X_MTF_5:
        case BZ_X_MTF_6:
                  //GET_UCHAR(BZ_X_ENDHDR_2, uc);
		   //switch(s.state){
	case BZ_X_ENDHDR_2:
	     s.state = BZ_X_ENDHDR_2;
             while (true) {                                 
                 if (s.bsLive >= 8) {                     
	             //long v; //UINT32                                
                     v = (s.bsBuff >>                        
			  (s.bsLive-8)) & _1lshft8m1;//((1 << 8)-1);   
                     s.bsLive -= 8;                        
                     uc = (byte)v;                                 
                     break;                                   
                 }                                           
                 if (s.strm.avail_in == 0){
                     retVal = BZ_OK; break save_state_and_return;
                 }
                 stream_op(s);
             }
	     if ((uc & 0xff) != 0x72){
                 //RETURN(BZ_DATA_ERROR);
                 if(dumpThreadOnError) Thread.dumpStack();
                 retVal = BZ_DATA_ERROR; break save_state_and_return;
             }
      //GET_UCHAR(BZ_X_ENDHDR_3, uc);
       case BZ_X_ENDHDR_3:
	   s.state = BZ_X_ENDHDR_3;
             while (true) {                                 
                 if (s.bsLive >= 8) {                     
	             //long v; //UINT32                                
                     v = (s.bsBuff >>                        
			  (s.bsLive-8)) & _1lshft8m1;//((1 << 8)-1);   
                     s.bsLive -= 8;                        
                     uc = (byte)v;                                 
                     break;                                   
                 }                                           
                 if (s.strm.avail_in == 0){
                     retVal = BZ_OK; break save_state_and_return;
                 }
                 stream_op(s);
             }
	     if ((uc & 0xff) != 0x45){
		 //RETURN(BZ_DATA_ERROR);
                 if(dumpThreadOnError) Thread.dumpStack();
                 retVal = BZ_DATA_ERROR; break save_state_and_return;
	     }
      //GET_UCHAR(BZ_X_ENDHDR_4, uc);
       case BZ_X_ENDHDR_4:
	   s.state = BZ_X_ENDHDR_4;
             while (true) {                                 
                 if (s.bsLive >= 8) {                     
	             //long v; //UINT32                                
                     v = (s.bsBuff >>                        
			  (s.bsLive-8)) & _1lshft8m1;//((1 << 8)-1);   
                     s.bsLive -= 8;                        
                     uc = (byte)v;                                 
                     break;                                   
                 }                                           
                 if (s.strm.avail_in == 0){
                     retVal = BZ_OK; break save_state_and_return;
                 }
                 stream_op(s);
             }
	     if ((uc & 0xff) != 0x38){
		 // RETURN(BZ_DATA_ERROR);
                 if(dumpThreadOnError) Thread.dumpStack();
                 retVal = BZ_DATA_ERROR; break save_state_and_return;
             }
      //GET_UCHAR(BZ_X_ENDHDR_5, uc);
       case BZ_X_ENDHDR_5:
	     s.state = BZ_X_ENDHDR_5;
             while (true) {                                 
                 if (s.bsLive >= 8) {                     
	             //long v; //UINT32                                
                     v = (s.bsBuff >>                        
			  (s.bsLive-8)) & _1lshft8m1;//((1 << 8)-1);   
                     s.bsLive -= 8;                        
                     uc = (byte)v;                                 
                     break;                                   
                 }                                           
                 if (s.strm.avail_in == 0){
                     retVal = BZ_OK; break save_state_and_return;
                 }
                 stream_op(s);
             }
	     if ((uc & 0xff) != 0x50){
                 //RETURN(BZ_DATA_ERROR);
                 if(dumpThreadOnError) Thread.dumpStack();
                 retVal = BZ_DATA_ERROR; break save_state_and_return;
             }
      //GET_UCHAR(BZ_X_ENDHDR_6, uc);
       case BZ_X_ENDHDR_6:
	     s.state = BZ_X_ENDHDR_6;
             while (true) {                                 
                 if (s.bsLive >= 8) {                     
	             //long v; //UINT32                                
                     v = (s.bsBuff >>                        
			  (s.bsLive-8)) & _1lshft8m1;//((1 << 8)-1);   
                     s.bsLive -= 8;                        
                     uc = (byte)v;                                 
                     break;                                   
                 }                                           
                 if (s.strm.avail_in == 0){
                     retVal = BZ_OK; break save_state_and_return;
                 }
                 stream_op(s);
             }
	     if ((uc & 0xff) != 0x90){
                 // RETURN(BZ_DATA_ERROR)
                 if(dumpThreadOnError) Thread.dumpStack();
                 retVal = BZ_DATA_ERROR; break save_state_and_return;
             }

      s.storedCombinedCRC = 0;
      //GET_UCHAR(BZ_X_CCRC_1, uc);
       case BZ_X_CCRC_1:
	   s.state = BZ_X_CCRC_1;
             while (true) {                                 
                 if (s.bsLive >= 8) {                     
	             //long v; //UINT32                                
                     v = (s.bsBuff >>                        
			  (s.bsLive-8)) & _1lshft8m1;//((1 << 8)-1);   
                     s.bsLive -= 8;                        
                     uc = (byte)v;                                 
                     break;                                   
                 }                                           
                 if (s.strm.avail_in == 0){
                     retVal = BZ_OK; break save_state_and_return;
                 }
                 stream_op(s);
             }     
	     s.storedCombinedCRC = ((s.storedCombinedCRC << 8) | (uc & 0xff)) & UINT32;//((UInt32)uc);
      //GET_UCHAR(BZ_X_CCRC_2, uc);
       case BZ_X_CCRC_2:
	     s.state = BZ_X_CCRC_2;
             while (true) {                                 
                 if (s.bsLive >= 8) {                     
	             //long v; //UINT32                                
                     v = (s.bsBuff >>                        
			  (s.bsLive-8)) & _1lshft8m1;//((1 << 8)-1);   
                     s.bsLive -= 8;                        
                     uc = (byte)v;                                 
                     break;                                   
                 }                                           
                 if (s.strm.avail_in == 0){
                     retVal = BZ_OK; break save_state_and_return;
                 }
                 stream_op(s);
             }
	     s.storedCombinedCRC = ((s.storedCombinedCRC << 8) | (uc & 0xff)) & UINT32;//((UInt32)uc);
      //GET_UCHAR(BZ_X_CCRC_3, uc);
       case BZ_X_CCRC_3:
	   s.state = BZ_X_CCRC_3;
             while (true) {                                 
                 if (s.bsLive >= 8) {                     
	             //long v; //UINT32                                
                     v = (s.bsBuff >>                        
			  (s.bsLive-8)) & _1lshft8m1;//((1 << 8)-1);   
                     s.bsLive -= 8;                        
                     uc = (byte)v;                                 
                     break;                                   
                 }                                           
                 if (s.strm.avail_in == 0){
                     retVal = BZ_OK; break save_state_and_return;
                 }
                 stream_op(s);
             }
	     s.storedCombinedCRC = ((s.storedCombinedCRC << 8) | (uc & 0xff)) & UINT32;//((UInt32)uc);
      //GET_UCHAR(BZ_X_CCRC_4, uc);
       case BZ_X_CCRC_4:
	     s.state = BZ_X_CCRC_4;
             while (true) {                                 
                 if (s.bsLive >= 8) {                     
	             //long v; //UINT32                                
                     v = (s.bsBuff >>                        
			  (s.bsLive-8)) & _1lshft8m1;//((1 << 8)-1);   
                     s.bsLive -= 8;                        
                     uc = (byte)v;                                 
                     break;                                   
                 }                                           
                 if (s.strm.avail_in == 0){
                     retVal = BZ_OK; break save_state_and_return;
                 }
                 stream_op(s);
             }
	     s.storedCombinedCRC = ((s.storedCombinedCRC << 8) | (uc & 0xff)) & UINT32;//((UInt32)uc);

      s.state = BZ_X_IDLE;
      //RETURN(BZ_STREAM_END);
      retVal = BZ_STREAM_END; break save_state_and_return;

      //default: AssertH ( False, 4001 );
	  //}
    }

       //AssertH ( False, 4002 );

   }//save_state_and_return:

   s.save_i           = i;
   s.save_j           = j;
   s.save_t           = t;
   s.save_alphaSize   = alphaSize;
   s.save_nGroups     = nGroups;
   s.save_nSelectors  = nSelectors;
   s.save_EOB         = EOB;
   s.save_groupNo     = groupNo;
   s.save_groupPos    = groupPos;
   s.save_nextSym     = nextSym;
   s.save_nblockMAX   = nblockMAX;
   s.save_nblock      = nblock;
   s.save_es          = es;
   s.save_N           = N;
   s.save_curr        = curr;
   s.save_zt          = zt;
   s.save_zn          = zn;
   s.save_zvec        = zvec;
   s.save_zj          = zj;
   s.save_gSel        = gSel;
   s.save_gMinlen     = gMinlen;
   s.save_gLimit      = gLimit;
   s.save_gBase       = gBase;
   s.save_gPerm       = gPerm;

   return retVal;   
   }


    public static void smallDecompress1(DState s, int nblock, byte uc){
	    int i,j;
 /**-- Make a copy of cftab, used in generation of T --*/
                       for (i = 0; i <= 256; i++) s.cftabCopy[i] = s.cftab[i];

                       /**-- compute the T vector --*/
                       for (i = 0; i < nblock; i++) {
                           uc = (byte)s.ll16.get(i);//(s.ll16[i]);
                           //SET_LL(i, s.cftabCopy[uc]);
                           SET_LL(s.ll4, s.ll16, i, s.cftabCopy[uc & 0xff]);
                           s.cftabCopy[uc & 0xff]++;
                       }

                       /**-- Compute T^(-1) by pointer reversal on T --*/
                       i = s.origPtr;
                       //j = GET_LL(i);
                           //((((UInt32)(s->ll4[(i) >> 1])) >> (((i) << 2) & 0x4)) & 0xF)
                           //(((UInt32)s->ll16[i]) | (GET_LL4(i) << 16))
                       j = s.ll16.getUInt16(i) | 
			       (((((s.ll4[((int)(i)) >> 1] & 0xff)) >> (((i) << 2) & 0x4)) & 0xF) << 16);
                       do {
                           //int tmp = GET_LL(j);
                           //((((UInt32)(s->ll4[(i) >> 1])) >> (((i) << 2) & 0x4)) & 0xF)
                           //(((UInt32)s->ll16[i]) | (GET_LL4(i) << 16))
                           int tmp = s.ll16.getUInt16(j) | 
			       (((((s.ll4[((int)(j)) >> 1] & 0xff)) >> (((j) << 2) & 0x4)) & 0xF) << 16);
                           //SET_LL(j, i);
                           SET_LL(s.ll4, s.ll16, j, i);
                           i = j;
                           j = tmp;
                       }
                       while (i != s.origPtr);

                       s.tPos = s.origPtr;
                       s.nblock_used = 0;
                       if (s.blockRandomised) {
	                   //BZ_RAND_INIT_MASK;
                           s.rNToGo = 0;                              
                           s.rTPos  = 0;
	                   //BZ_GET_SMALL(s.k0);
                           s.k0 = BZLib.BZ2_indexIntoF ((int)s.tPos, s.cftab );    
                           //s.tPos = GET_LL(s->tPos);
                           //#define GET_LL4(i)				\
                           //((((UInt32)(s->ll4[(i) >> 1])) >> (((i) << 2) & 0x4)) & 0xF)
                           //(((UInt32)s->ll16[i]) | (GET_LL4(i) << 16))
                           s.tPos = (s.ll16.getUInt16((int)s.tPos) | 
				     (((((s.ll4[((int)(s.tPos)) >> 1] & 0xff)) >> (((s.tPos) << 2) & 0x4)) & 0xF) << 16)) & UINT32;
                           s.nblock_used++;
                           //BZ_RAND_UPD_MASK; 
                           if (s.rNToGo == 0) {                       
                               s.rNToGo = BZ2_rNums[s.rTPos];         
                               s.rTPos++;                              
                               if (s.rTPos == 512) s.rTPos = 0;       
                           }
                           s.rNToGo--;
                           //BZ_RAND_MASK ((s->rNToGo == 1) ? 1 : 0)
                           s.k0 ^= ((s.rNToGo == 1) ? 1 : 0); //BZ_RAND_MASK; 
		       } else {
                           //BZ_GET_SMALL(s.k0); 
                           //#define BZ_GET_SMALL(cccc)
                           //cccc = BZ2_indexIntoF ( s->tPos, s->cftab );
                           //s->tPos = GET_LL(s->tPos);
                           s.k0 = BZLib.BZ2_indexIntoF((int)s.tPos, s.cftab);
                           s.tPos = (s.ll16.getUInt16((int)s.tPos) | 
				     (((((s.ll4[((int)(s.tPos)) >> 1] & 0xff)) >> (((s.tPos) << 2) & 0x4)) & 0xF) << 16)) & UINT32;
                           s.nblock_used++;
                       }
		       s._i = i; s._j = j; s._uc = uc;
    }





}